---
schema_version: "1"
id: 1dd762317ac24ea87fa35eb2c33130f1af737fce82403180ecba055d23d10101
title: Loyalty SPI
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/retail-cloud/reference/generated-api-specs/loyalty-spi.md
canonical_url: https://developer.salesforce.com/docs/commerce/retail-cloud/references/loyalty-spi
source_site: developer.salesforce.com
content_type: documentation
content_hash: 00e91a341270ec723ecc61755ec79f1bdf75cac5a29dd99b9a5b2ba1f8293387
products:
  - Point of Sale for Developers
  - Salesforce APIs
---
Loyalty SPI

# Loyalty SPI

[Download specification](https://developer.salesforce.com/static/commercecloud/retail-cloud/loyalty-spi/loyalty-spi-oas-public.yaml)

Sample APIs that demonstrate how to implement API endpoints or webhooks in the merchant's system. These endpoints must be configured in the POS system so that the POS can use them to send order details and get loyalty-related information.

**Version:** 2.3.4

## Tags

### Loyalty SPI

[Download specification](https://developer.salesforce.com/static/commercecloud/retail-cloud/loyalty-spi/loyalty-spi-oas-public.yaml)

Sample APIs that demonstrate how to implement API endpoints or webhooks in the merchant's system. These endpoints must be configured in the POS system so that the POS can use them to send order details and get loyalty-related information.

## Operations

### POST Retrieve loyalty points earned.

`POST /merchant/spi/sample/endpoint/sa/getLoyaltyPoints`

Operation ID: `postReceipt_1`. Tags: Loyalty SPI.

Retrieve the loyalty points earned for the transaction. When placing an order, if the customer is enrolled in loyalty, this SPI returns the points that will be earned for the order. Merchant must implement this endpoint per this specification and then configure it in CMS.

#### Request body

Media type: `application/json`. Schema: `Cart`.

#### Responses

*   **default** Default response.
    
    Media type: `application/json`. Schema: `SPILoyaltyPoints`.
    

## Schemas

### Cart

*   `cartId` (_string_)
*   `suspendedCartId` (_string_, nullable) If the cart is created from suspended cart,the suspendedCartId will be populated with the suspended cart's db id. This is nothing but db id of the resumed suspended cart.
*   `suspendedQuoteId` (_string_, nullable) If the cart is created from suspended cart having quote,the suspendedQuoteId will be populated with the suspended cart's quoteId.
*   `suspendedExternalQuoteId` (_string_, nullable) If the cart is created from suspended cart having quote,the suspendedExternalQuoteId will be populated with the suspended cart's external quoteId.
*   `resumedCartDBIds` (_array of string_, nullable) All the resumed cart associated with this current cart. Multiple suspended carts can be resumed in single active cart, all such resumed carts are maintained in this list.  
    Unique items.
*   `cartItemList` (_array of Product_)
*   `subTotal` (_number_)
*   `shippingMethodList` (_array of ShippingMethod_)
*   `session` (_string_)
*   `orderNo` (_string_)
*   `discount` (_number_)
*   `errors` (_array of ProductError_)
*   `productWarnings` (_array of ProductWarning_)
*   `productPriceAdjustments` (_array of ProductPriceAdjustment_)
*   `orderPriceAdjustments` (_array of OrderPriceAdjustment_)
*   `originalDiscountData` (_CartDiscountData_)
*   `giftCardList` (_array of GiftCard_)
*   `giftCardAppliedTotal` (_number_)
*   `paymentMerchantId` (_string_)
*   `paymentOrganizationId` (_string_)
*   `token` (_string_)
*   `errorCode` (_string_)
*   `errorMessage` (_string_)
*   `taxCalculationDone` (_boolean_)
*   `hybridCheckoutUrl` (_string_)
*   `rewardList` (_array of Reward_)
*   `rewardTotal` (_number_)
*   `cookieList` (_array of CheckoutCookie_)
*   `tax` (_number_)
*   `valueAddedTax` (_number_)
*   `highPrecisionValueAddedTax` (_number_)
*   `giftCardRemainingTotal` (_number_)
*   `giftWrapTotal` (_number_)
*   `giftMessage` (_string_)
*   `promotions` (_array of Promotion_)
*   `promotionCodes` (_array of string_)
*   `shippingAddress` (_Address_)
*   `billingAddress` (_Address_)
*   `taxTotal` (_number_)
*   `taxExemption` (_number_)
*   `shippingTotal` (_number_)
*   `shippingDiscount` (_number_)
*   `totalDiscount` (_number_, nullable) Order Total Savings - Total discount amount applied to the order, combining all discount sources (item-level + transaction-level + promotion-level + shipping discounts). Excludes price corrections.
*   `shippingMethod` (_ShippingMethod_)
*   `priceAdjustmentsComplete` (_boolean_)
*   `redeemPromoCallBackUrl` (_string_)
*   `loyaltyId` (_string_)
*   `customerEmail` (_string_)
*   `orderSource` (_string_)  
    Allowed values: `DEFAULT`, `IN_STORE`, `POPUP_STORE`, `WEB`, `APP`, `OUTLET_STORE`, `ONLINE`, `POS_EA`.
*   `transactionStartDate` (_string (date-time)_)
*   `fullfillmentType` (_string_)  
    Allowed values: `IN_STORE`, `ONLINE`, `MIXED_CART`.
*   `storeId` (_string_)
*   `customerId` (_string_)
*   `taxableAmount` (_number_)
*   `isSplitCart` (_boolean_)
*   `children` (_object_)
    
    Additional properties: `Cart`.
    
*   `transactionDiscountAmount` (_number_)
*   `transactionDiscountReason` (_string_, deprecated) DEPRECATED - Use 'reasons' instead.
*   `offlineMode` (_boolean_)
*   `loyaltyInfo` (_LoyaltyInfo_)
*   `taxRates` (_array of OrderTaxRate_) Sale-side tax rate.
*   `taxExemptions` (_array of TaxExemptionRequest_) Sale-side tax exemptions.
*   `vatRates` (_array of OrderTaxRate_) Sale-side VAT rate.
*   `netTaxRates` (_array of OrderTaxRate_) Net tax rate calculated based on sale-side tax rate and return-side tax rate.
*   `netVatRates` (_array of OrderTaxRate_) Net VAT rate calculated based on sale-side VAT rate and return-side VAT rate.
*   `reasons` (_array of Reason_, read-only, nullable) List of reasons pertaining to the actions performed on the cart. For example, reason for discounts applied to the order.
*   `editOrderId` (_string_, nullable) Order ID for the order being edited.
*   `exchangeItemResponses` (_array of ExchangeItemResponse_) Details about the items that are being returned or exchanged.
*   `returnsTenders` (_array of ReturnsTender_) In case there is refund, refund tender details and options.
*   `amountToBeCharged` (_number_) Amount to be charged.
*   `paidAmount` (_number_) Used in edit order flow. Amount already paid as part of original order.
*   `orderType` (_string_) Used to indicate if the order is of type Layaway.  
    Allowed values: `STORE_PICKUP`, `STORE_FULFILLMENT`, `LAYAWAY`, `MIXED_MODE`, `ONLINE`, `ONLINE_RESERVE`.
*   `minTransactionDiscountAmount` (_number_) Used in edit order flow. Minimum transaction discount that must be applied to cover for transaction discount already applied on already fulfilled products.
*   `maxTransactionDiscountAmount` (_number_) Used in edit order flow. Maximum transaction discount that can be applied.
*   `minimumPaymentAmount` (_number_) Used for partial payments flow. Represents minimum payment amount due at the time of order placement.
*   `notesList` (_array of OrderNote_)
*   `grandTotal` (_number_) Grand Total of sale transaction. Cart can have items for a sale transaction or a return transaction or for a transaction that is being performed for both sale and returns in single checkout. In all such scenarios, Grand Total is to maintain total sale amount. In case of pure returns, the Grand Total will always be zero.
*   `hash` (_string_) Hash corresponding to the current cart content.
*   `saleRoundingAmount` (_number_) The delta amount because of rounding applied on sale portion of the cart.
*   `exchangeItemRequests` (_array of ExchangeItemRequest_) Request for items that are being returned or exchanged.
*   `refundSubTotal` (_number_) Returning item subtotal — subtotal of items in the exchange item list.
*   `refundDiscount` (_number_) Returning item's discount — discount total of items in the exchange item list.
*   `refundTax` (_number_) Returning item's tax — tax total of items in the exchange item list.
*   `refundTariff` (_number_) Returning item's tariff — tariff total of items in the exchange item list.
*   `refundTaxExemption` (_number_) Returning item's tax exemption — tax exemption total of items in the exchange item list.
*   `refundValueAddedTax` (_number_) Returning item's value-added tax — VAT for items in the exchange item list.
*   `refundItemTotal` (_number_) Returning item's total — total of items in the exchange item list.
*   `profile` (_Profile_)
*   `refundFees` (_array of RefundFee_) Refund fees applied when cancelling items from an order during the edit order flow.
*   `taxTransaction` (_TaxTransaction_)
*   `externalSessionId` (_string_)
*   `referenceId` (_string_, nullable) Two phase confirmation reference id corresponding to the order that is being confirmed as part of this request, Two phase commit V2 uses this field.
*   `externalCartId` (_string_)
*   `orderLevelGiftWrap` (_OrderLevelGiftWrap_)
*   `paymentInstallment` (_PaymentInstallment_)
*   `paymentInstallmentOptionsList` (_array of PaymentInstallmentOptions_, nullable) List of Payment Installment options available.
*   `isGift` (_boolean_) Flag indicating if order is a gift.  
    Default: `false`.
*   `pickUpDetail` (_OrderPickUpDetail_)
*   `pickUpDetailList` (_array of OrderPickUpDetail_) Pick Up Details.
*   `deliveryZoneId` (_string_) Zone ID for online items that will be delivered.
*   `deliveryZipCodeId` (_string_) Zip code ID for online items that will be delivered.
*   `availableDate` (_integer (int64)_) Available date for online items.
*   `totalAssembledQty` (_number (double)_) Total Assembled quantity for delivery items.
*   `totalBoxedQty` (_number (double)_) Total Boxed quantity for delivery items.
*   `verifiedTenderInfo` (_array of Tender_) Information which was used to verify the tender is available through this list.
*   `authorizedTenderInfo` (_array of Tender_) Information which was used to authorize the tender is available through this list.
*   `summary` (_CartSummary_)
*   `transactionDiscount` (_Discount_)
*   `shippingDisclaimer` (_string_) Shipping Disclaimer.
*   `employee` (_Employee_)
*   `cartType` (_string_, nullable) Used in the backend to determine if the omni flow is active during cart, order, and order post-processing.  
    Allowed values: `REGULAR`, `OMNI`.
*   `displayMessages` (_array of Flash_) Generic field for display messages. The display message is populated to provide helpful information to user. One of the use cases is eligible coupon code which is not applied.
*   `multiShipmentType` (_string_) Multi shipment types as cart can have multiple shipments either with the same address or different addresses.  
    Allowed values: `ORDER_LEVEL`, `DELIVERY_GROUP_LEVEL`.
*   `auxiliaryItemData` (_array of AuxiliaryItemData_) Auxiliary items details support for edit order.
*   `skipAutoPromotion` (_boolean_) Skip auto promotion when the order is edit order.
*   `currentStoreType` (_string_) Store Type belonging to current store requesting cart.  
    Allowed values: `Regular`, `Popup`, `Outlet`, `Ecomm`, `Warehouse`, `DistributionCenter`, `Vendor`.
*   `customerLoyaltyProfile` (_CustomerLoyaltyProfile_)
*   `pointsEarned` (_integer (int32)_, nullable) The number of loyalty points earned in this transaction.
*   `shippingTaxExemption` (_number_, nullable) The tax exemption applied on the Shipping tax.
*   `originalDepositBalance` (_number_)
*   `depositBalance` (_number_)
*   `depositToOrderBalance` (_number_)
*   `returnCustomerInformation` (_ReturnCustomerInformation_)
*   `deltaCart` (_DeltaCart_)
*   `tariffAmount` (_number_)
*   `tariffRate` (_number_)
*   `taxOrVatOverrideRate` (_number_)
*   `partiallyPaidItemList` (_array of Product_)
*   `isWarrantyStale` (_boolean_)
*   `promotionContext` (_array of Promotion_)
*   `promotionContextV2` (_array of Promotion_)
*   `skipDeliveryGroupSPI` (_boolean_)

### SPILoyaltyPoints

*   `pointsEarned` (_integer (int32)_) The number of loyalty points earned for an order, dedicated SPI will give the value for this post Phase I call.

### Product

The details of product's deposit. For example, order item ID, required deposit, and paid deposit.

*   `productId` (_string_, required) Product ID. Unique identifier of an item.  
    All the variations of an item will have distinct product id hence it is equivalent to SKU.
*   `variantGroupId` (_string_, required) Variant Group ID.  
    All the variants of an item are grouped together under the same variant id.
*   `name` (_string_, required) Name of the item.
*   `price` (_number_, required) Price of the item.
*   `quantity` (_integer (int32)_, required) Item's Quantity.
*   `productTax` (_ProductTax_)
*   `tax` (_number_, nullable) Total tax on this product.  
    Mandatory for tax countries and applies to products that are subject to taxation.  
    
*   `taxExemption` (_number_, nullable) Tax exemption amount  
    Applicable if the tax exemption is applied by store associate during checkout process.  
    
*   `valueAddedTax` (_number_, nullable) Total VAT on this product. Mandatory for VAT countries.
*   `orderItemId` (_string_, required) Sequence number assigned to this line item.  
    Must be unique within this order and must have numerical value.  
    Example: `It can have values like 1, 2, 3, etc...<br> which represents line item number within the order.`.
*   `imageURL` (_string_, required) Image URL of the item.It is used to display the image of the item in the cart, order summary screens. email.
*   `subTotal` (_number_, required) The total cost of the item is inclusive of VAT,  
    but exclusive of discounts, shipping fees, and taxes.
*   `discount` (_number_, nullable) Total discount applied on the item.  
    It is the sum of all the discounts applied on the item.  
    The discount includes manual price adjustments  
    (i.e. item level price override & transaction discount) and  
    promotions (i.e. coupons, auto promotion & reward coupon)  
    Mandatory if any type of discounts is applied.
*   `total` (_number_, required) Item's total — final amount charged for this item, inclusive of tax/vat and discounts.
*   `store` (_Store_)
*   `size` (_string_, required) Item's size.  
    Example: `39-42 or M or 38 etc...`.
*   `color` (_string_, required) Item's color.  
    Example: `Light Grey or Black etc...`.
*   `itemStatus` (_string_, required)
    
    Below is the list of statuses for in-store purchases and BORIS. The statuses are applicable for both the order and its items. The significance of each status is described in detail below.  
    The eligibility of an item for returns is determined by its current status and the status of the order. Moreover, the **returnsEligibility** attribute at the item level (productList, orderProductList) can also be used to regulate the return eligibility of an item.  
    To learn more about returns eligibility, please refer to the table below and orderProductList.returnsEligibility/productList.returnsEligibility  
      
    
    | Order Status | Display Name in Order History Filter | Significance for Order | Significance for Item | Return Eligibility |
    | --- | --- | --- | --- | --- |
    | COMPLETED | Completed | Successful sale transaction. | Item sold successfully. | Both the order and item are eligible for return. |
    | RETURNED | Returned | Successful return or exchange of all items with refund to customer. | Successful return of an item - whole quantity and is not eligible for return. | Both the order and item are not eligible for return. |
    | PARTIALLY\_REFUNDED | Partially Returned | Successful return or exchange of partial items with refund to customer. | Successful return of an item - partial quantity | Further returns are allowed on order as well as on item. |
    | EXCHANGED | Exchanged | Successful transaction that exchanges all items with no refund to customer | Successful exchanges of an item - whole quantity | Both the order and item are not eligible for return. |
    | PARTIALLY\_EXCHANGED | Partially Exchanged | Successful transaction that exchanges partial items with no refund to customer | Successful exchanges of an item - partial quantity | Further returns are allowed on order as well as on item. |
    | FAILED | Failed | Failed sale transaction. | Not applicable | Both the order and item are not eligible for return. |
    | PENDING | Pending | Sale transaction awaiting payment confirmation. For example, Remote Pay By Link | Not applicable | Both the order and item are not eligible for return. |
    
      
    Allowed values: `NEW`, `PROCESSING`, `PARTIALLY_SHIPPED`, `SHIPPED`, `CANCELED`, `COMPLETED`, `FAILED`, `RETURNED`, `PARTIALLY_REFUNDED`, `REWARD`, `PENDING`, `UNKNOWN`, `READY`, `PACK`, `UNPACK`, `PICKED`, `DELIVERED`, `CREATED`, `CANCELLED_WITH_REFUND`, `UNAVAILABLE`, `DAMAGED`, `EXCHANGED`, `PARTIALLY_EXCHANGED`, `RECREATED`, `FULFILLED`, `PENDING_ORDER`, `IN_TRANSIT`, `EDITED`.
*   `returnedDateTimeStamp` (_integer (int64)_, nullable) Timestamp when the item is returned.  
    Mandatory if the item is returned and is part of returnProductList  
    When importing an order from external system and if it has returnProductList, ensure to provide this returned date.
*   `totalAdditionalCharge` (_number_, nullable) Total additional charges applied on the item.  
    It is the sum of all the additional charges applied on the item.  
    Mandatory if any type of additional charges is applied.  
    Additional charges include CRV, Liquor Tax etc.
*   `additionalCharges` (_array of AdditionalCharge_, nullable) List of additional charges applied on the item.  
    It is used to capture additional charges like CRV, Liquor Tax etc.
*   `gtin` (_string_, required) Item's GTIN.
*   `fulfillmentType` (_string_, required) Item's fulfillment type. It can be either IN\_STORE (in-store purchase) or ONLINE (delivery item).  
    Allowed values: `IN_STORE`, `ONLINE`, `MIXED_CART`.
*   `fulfillmentSubType` (_string_, required)
    
    1.  DEFAULT: Either item will be available from the current store for  
         cash & carry or for delivery to shipping address from a warehouse.  
          Fulfillment Type:IN\_STORE, Fulfillment Sub Type: DEFAULT : Cash & carry item  
        2\. TRY\_AT\_STORE: An item will be made available in the selected store for the trial.  The taxes and promotion will not be applied on the try at store items.  
        3\. PICKUP\_LATER: An item will be made available for pickup from the selected store.  The fulfillment will be done the current store itself, or another store.  
        4\. SHIP\_TO\_HOME: An item will be delivered to provided shipping address.  The fulfillment will be done by the current store itself,  or another store or a warehouse.  
        5\. SHIP\_TO\_STORE: An item will be delivered to a store from where it can be picked up. 6. PICKUP\_NEARBY: An item will be made available for pickup in near by store.  
        \----------------------------------------------------------------------------------  
        
    
    | Fulfillment Type | Fulfillment SubType | Item |
    | --- | --- | --- |
    | IN\_STORE | DEFAULT | Cash & carry |
    | ONLINE | DEFAULT | Ship to home from warehouse |
    | ONLINE | TRY\_AT\_STORE | Ship to store from warehouse to try out |
    | IN\_STORE | PICKUP\_LATER | Pickup from current store |
    | IN\_STORE | SHIP\_TO\_HOME | Ship to home from store |
    | IN\_STORE | SHIP\_TO\_STORE | Ship to a store from another store for pickup |
    | ONLINE | SHIP\_TO\_STORE | Ship to store from warehouse for pickup (buy online ship to store) |
    | IN\_STORE | PICKUP\_NEARBY | Pickup from another store |
    
    .
    
      
    Allowed values: `DEFAULT`, `BOSS`, `BOPIS`, `TRY_AT_STORE`, `PICKUP_LATER`, `SHIP_TO_HOME`, `SHIP_TO_STORE`, `PICKUP_NEARBY`.
*   `notesList` (_array of OrderDetailNote_, nullable) List of notes/comments captured at product level during order submission.If the notes are provided when importing an order from an external system,  
    they will be available for store associate in order history screen of POS App.  
    
*   `salesAssociateId` (_string_, required) The ID of the logged-in store associate.
*   `salesAssociateAttribution` (_array of OrderStoreAssociateAttribution_, nullable) Sales associate attribution.  
    If not provided, POS attributes the item to the logged-in store associate.  
    
*   `returnsEligibility` (_string_, nullable) Returns eligibility of the item.  
    It is used to determine if the item is eligible for returns or not.  
    When importing an order from an external system, item's return-eligibilitycan be controlled by providing appropriate value here.  
    CANNOT\_BE\_RETURNED blocks the return even if item's status is COMPLETED.  
      
    Allowed values: `ELIGIBLE_FOR_RETURNS`, `EXPIRED_RETURNS`, `CANNOT_BE_RETURNED`, `ELIGIBLE_FOR_CANCELS`, `INELIGIBILITY_FOR_RETURN_CROSS_CHANNEL`. Default: `ELIGIBLE_FOR_RETURNS`.
*   `returnsEligibilityText` (_string_) Returns eligibility information for the product, describing why it's ineligible for return. For example, BOFIS items that haven't shipped can't be returned. In that case, this field says 'Item not shipped yet' (applies when BOFIS orders are sent to PS Queue, that is, STH from CS enabled in Omni V2 settings). When an item can't be returned, this field says 'Cannot be returned'.  
    Maximum length: 128.
*   `appeasementEligibility` (_string_, nullable) Appeasement eligibility of the item.  
    It is used to determine if the item is eligible for price adjustment or not in edit order flow  
    When importing an order from an external system, item's appeasement-eligibilitycan be controlled by providing appropriate value here.  
    INELIGIBLE\_FOR\_APPEASEMENT blocks any adjustment even if item's status is COMPLETED.  
      
    Allowed values: `ELIGIBLE_FOR_APPEASEMENT`, `INELIGIBLE_FOR_APPEASEMENT`.
*   `cyoDetails` (_CyoDetails_)
*   `epc` (_string_, nullable) Electronic product code. Mandatory for items having epc/RFID.
*   `tlogCustomProductAttributes` (_string_, read-only, nullable) Custom product attributes.  
    It is used to capture custom attributes of the product.  
    If the product has any custom attributes, they will be captured here.  
    Store settings (**CMS** > **Store Management** > **Store Settings** > **OMS**\>  
    Order Export > tLogCustomProductAttributes) needs be configured with  
    the list of custom attributes to be populated here.  
    It it is not required when importing an order from an external system.  
    
*   `masterProductId` (_string_, nullable) Outfit Identification that groups together a set of items from a cart.  
    Commonly used in case product customizations like DYO (i.e. Customization Identification) or Alteration etc...Mandatory for alteration or DYO items.
*   `subProducts` (_array of Product_, nullable) The other items from the cart related to the current item.  
    Commonly used in case of customizations like Alteration as well as for add-on products.  
    Mandatory for alteration or add-on items.  
    No need to provide this attribute, when importing an order and  
    if the item doesn't have add-on item.
*   `productBundleId` (_string_, nullable) If the product is part of outfit or a product bundle, then provide the id which groups together all the items from the bundle.
*   `productClass` (_string_, required) Product class of the item.
*   `serialNumber` (_string_) Serial number of the item (if applicable).
*   `productCondition` (_string_, nullable) Product condition.  
    Allowed values: `NEW`, `USED`, `REFURBISHED`. Default: `NEW`.
*   `reasons` (_array of Reason_, nullable) List of reasons pertaining to the actions performed on the item. For example, reason for price override applied on the item or reason for returning the item.
*   `dateTimeSlot` (_DateTimeSlot_)
*   `promotionTitle` (_string_, nullable) Provides applicable promotion titles in pipe delimited format. If the item is qualified for multiple promotions, promotionTitle will have multiple titles in delimited form.It is used to display the promotion title on the item in order history screen of POS App.  
    Example: `Winter discount| Holiday special`.
*   `priceCorrection` (_OrderDetailPriceCorrection_)
*   `fulfillmentLocation` (_Store_)
*   `pickupLocation` (_Store_)
*   `deliveryGroupId` (_string_, nullable) Delivery Group Id - It is an identifier to the shipping details of the item.  
    It links the item to one of the delivery groups available in order level.  
    It is used for item level shipping method and address.  
    Mandatory for all delivery items if item level shipping method  
    or item level shipping address is enabled.  
    For more details, see:  
    1\. Item level shipping method:  
    [Retrieve Delivery and Pickup Dates via SPI](https://developer.salesforce.com/docs/commerce/retail-cloud/guide/retrieve-delivery-pickup-dates-via-spi.html) 2. Item level shipment Address:  
    [Retrieve Delivery and Pickup Dates via SPI](https://developer.salesforce.com/docs/commerce/retail-cloud/guide/retrieve-delivery-pickup-dates-via-spi.html)  
    Maximum length: 32.
*   `formAttributes` (_array of ProductFormAttribute_, nullable) Product from attributes.
*   `pickupDetailId` (_string_, nullable) Provide a link to the corresponding pickup details  
    from pickupDetailList available in the order. Applicable for pickup items.  
    
*   `registryId` (_string_, nullable) The unique ID of the registry. This is required when the item being purchased or returned is a gift registry item.
*   `requiredDeposit` (_number_) Required deposit for the product if deposit configuration is enabled for the store.
*   `paidDeposit` (_number_) Paid deposit for the product if deposit configuration is enabled for the store.
*   `originalPaidDeposit` (_number_)
*   `serializedUnitDetailList` (_array of SerializedUnitDetail_, nullable) Attributes for each individual unit of the product, for example, activation code or context code.
*   `customAttributeList` (_array of ProductFormAttribute_, read-only) Custom attributes related to the product.  
    All these attributes will be available at item level that are  
    configured in Store Setting: spiCustomProductAttributes.
    
    _Example_
    
    ```
    [
      {
        "key": "color",
        "value": "red"
      }
    ]
    ```
    
*   `itemTariff` (_number_, nullable) The item tariff amount at the time of sale. This value is retrieved from **CMS** > **Store Settings** > **Tariffs** and is included only when the tariff configuration is available in CMS.
*   `groupId` (_string_)
*   `returnRelated` (_boolean_)
*   `mainProduct` (_boolean_)
*   `shippingAddress` (_Address_)
*   `requiredDepositPercentage` (_number_)
*   `virtual` (_boolean_)

### ShippingMethod

Available shipping methods corresponding to this delivery group.

*   `shippingMethodId` (_string_, required) Unique Identifier for the Shipping Method.  
    Maximum length: 45. Example: `001`.
*   `name` (_string_, required) Shipping Method Name.  
    Maximum length: 128. Example: `Standard Shipping`.
*   `description` (_string_, nullable) Shipping Method Description.  
    Maximum length: 128.
*   `carrier` (_string_, nullable) Shipping carrier, for example, UPS, USPS, FedEx, or DHL.  
    Maximum length: 32. Example: `UPS`.
*   `serviceLevel` (_string_, nullable) Service Level Description.  
    E.g. 3-5 Days, 1-Day, Express, Standard, Overnight.  
    Maximum length: 128. Example: `3-5 Days`.
*   `price` (_number_, required) Shipping cost.
*   `priceAdjustments` (_array of PriceAdjustment_, nullable) Price adjustments after applying shipping level promotion. Supported PriceAdjustmentType - PROMOTION only.
*   `priceAfterShippingDiscount` (_number_, nullable) Price after applying shipping discount.
*   `sortOrder` (_integer (int32)_) Display Order.  
    Default: `0`.
*   `taxRates` (_array of ProductTaxRate_, nullable) Tax breakdown for the shipping cost. Applicable for tax countries and if the shipping cost is taxable.
*   `vatRates` (_array of ProductTaxRate_, nullable) VAT breakdown for the shipping cost. Applicable for VAT countries and if the shipping cost is taxable.
*   `shippingTax` (_number_, nullable) Tax amount for the shipping cost. Applicable for tax countries and if the shipping cost is taxable.
*   `shippingValueAddedTax` (_number_, nullable) VAT amount for the shipping cost. Applicable for vat countries and if the shipping cost is taxable.
*   `taxClass` (_string_, deprecated) Refer taxRates or vatRates instead to know the tax class.
*   `taxExemption` (_number_, nullable) Tax exemption amount for the shipping cost. Applicable for tax countries and if the shipping cost is taxable and tax exemption is applied.
*   `deliveryDate` (_integer (int64)_, required) Expected delivery date in epoch in millis.
*   `deliveryTimeSlot` (_string_, required) Expected delivery time slot.  
    Example: `09:00 - 12:00`.
*   `itemLevelCharges` (_array of ItemLevelCharge_, nullable) Item level breakdown for the shipping cost and shipping discount.

### ProductError

*   `productId` (_string_)
*   `errorMessage` (_string_)
*   `errorCode` (_string_)
*   `errorType` (_string_)

### ProductWarning

*   `productId` (_string_)
*   `messages` (_array of Message_)

### ProductPriceAdjustment

*   `productId` (_string_)
*   `basePrice` (_string_)
*   `adjustedPrice` (_string_)
*   `priceAdjustments` (_array of PriceAdjustment_)
*   `orderItemId` (_string_)
*   `priceAfterItemDiscount` (_number_)
*   `priceAfterOrderDiscount` (_number_)
*   `totalAdjustedPrice` (_number_)
*   `totalTaxablePrice` (_number_)
*   `totalAddtionalCharge` (_number_)
*   `totalItemDiscount` (_number_)
*   `fulfillmentType` (_string_)  
    Allowed values: `IN_STORE`, `ONLINE`, `MIXED_CART`.
*   `fulfillmentSubType` (_string_)
    
    1.  DEFAULT: Either item will be available from the current store for  
         cash & carry or for delivery to shipping address from a warehouse.  
          Fulfillment Type:IN\_STORE, Fulfillment Sub Type: DEFAULT : Cash & carry item  
        2\. TRY\_AT\_STORE: An item will be made available in the selected store for the trial.  The taxes and promotion will not be applied on the try at store items.  
        3\. PICKUP\_LATER: An item will be made available for pickup from the selected store.  The fulfillment will be done the current store itself, or another store.  
        4\. SHIP\_TO\_HOME: An item will be delivered to provided shipping address.  The fulfillment will be done by the current store itself,  or another store or a warehouse.  
        5\. SHIP\_TO\_STORE: An item will be delivered to a store from where it can be picked up. 6. PICKUP\_NEARBY: An item will be made available for pickup in near by store.  
        \----------------------------------------------------------------------------------  
        
    
    | Fulfillment Type | Fulfillment SubType | Item |
    | --- | --- | --- |
    | IN\_STORE | DEFAULT | Cash & carry |
    | ONLINE | DEFAULT | Ship to home from warehouse |
    | ONLINE | TRY\_AT\_STORE | Ship to store from warehouse to try out |
    | IN\_STORE | PICKUP\_LATER | Pickup from current store |
    | IN\_STORE | SHIP\_TO\_HOME | Ship to home from store |
    | IN\_STORE | SHIP\_TO\_STORE | Ship to a store from another store for pickup |
    | ONLINE | SHIP\_TO\_STORE | Ship to store from warehouse for pickup (buy online ship to store) |
    | IN\_STORE | PICKUP\_NEARBY | Pickup from another store |
    
    .
    
      
    Allowed values: `DEFAULT`, `BOSS`, `BOPIS`, `TRY_AT_STORE`, `PICKUP_LATER`, `SHIP_TO_HOME`, `SHIP_TO_STORE`, `PICKUP_NEARBY`.
*   `additionalCharges` (_array of AdditionalCharge_)

### OrderPriceAdjustment

The list of price adjustments done on the total order in the cart.

*   `description` (_string_)
*   `adjustment` (_number_)
*   `discount` (_Discount_)
*   `price` (_number_)
*   `promotionId` (_string_)
*   `fulfillmentType` (_string_)  
    Allowed values: `IN_STORE`, `ONLINE`, `MIXED_CART`.

### CartDiscountData

*   `transactionDiscount` (_number_) The transaction discount applied on the original order.
*   `productPriceAdjustments` (_array of ProductPriceAdjustment_) Item level price adjustments applied on the original order. It can be price override, promotion or prorated transaction discount.

### GiftCard

*   `cardId` (_string_)
*   `cardNumber` (_string_)
*   `cardPin` (_string_)
*   `balance` (_number_)
*   `invoiceNumber` (_string_)
*   `token` (_string_)
*   `forcePinValidation` (_boolean_)
*   `approvedAmount` (_number_)
*   `transactionId` (_string_)
*   `returnRelated` (_boolean_)

### Reward

Earned rewards.

*   `issueDate` (_integer (int64)_)
*   `expiryDate` (_integer (int64)_)
*   `description` (_string_)
*   `amount` (_number_) Amount value of the reward. Required for reward types : Discount and Tender.
*   `rewardName` (_string_)
*   `code` (_string_)
*   `pin` (_string_)
*   `codeType` (_string_)
*   `labelText` (_string_)
*   `disclaimerText` (_string_)
*   `rewardType` (_string_)  
    Allowed values: `Discount`, `Coupon`, `Tender`.
*   `isImageOnly` (_boolean_)
*   `rewardImageURL` (_string_)
*   `rewardInputType` (_string_)
*   `status` (_string_)  
    Allowed values: `REDEEMED`, `EXPIRED`, `AVAILABLE`, `CANCELLED`.
*   `statusDesc` (_string_)
*   `canRedeemNow` (_boolean_)
*   `redeemedDate` (_integer (int64)_)
*   `customAttributes` (_object_)
    
    Additional properties: `object`.
    
*   `rewardId` (_string_, required, read-only) The ID of the loyalty reward. In the case of reward coupon,  
    it will be coupon code. In the case of discount reward, it is unique identifier.  
    Maximum length: 512.
*   `combinable` (_boolean_) Specifies whether multiple rewards can be applied to the same cart.
*   `points` (_integer (int32)_, nullable) Optional points value for the reward, if sent, it will be used for display and for validation against the current points of the customer ( loyaltyProfile.currentPoints).

### CheckoutCookie

*   `domain` (_string_)
*   `key` (_string_)
*   `value` (_string_)

### Promotion

*   `merchantId` (_string_)
*   `locale` (_string_)
*   `region` (_string_)
*   `promotionId` (_string_)
*   `name` (_string_)
*   `title` (_string_)
*   `description` (_string_)
*   `promoCode` (_string_)
*   `inStorePromoCode` (_string_)
*   `appPromoCode` (_string_)
*   `onlinePromoCode` (_string_)
*   `outletPromoCode` (_string_)
*   `promoFeedSource` (_FeedSource_)
*   `startTimeStamp` (_integer (int64)_)
*   `endTimeStamp` (_integer (int64)_)
*   `combinationTypes` (_array of string_)
*   `channel` (_array of string_)  
    Items: Allowed values: `ALL`, `WEB`, `APP`, `STORE`, `OUTLET`.
*   `priorityOrder` (_integer (int32)_)
*   `active` (_boolean_)
*   `auto` (_boolean_)
*   `redemptionLimit` (_number (double)_)
*   `uniqueCodeUrl` (_string_)
*   `redeems` (_number (double)_)
*   `barCodeType` (_string_)
*   `promotionType` (_string_)  
    Allowed values: `ORDER_PERCENT_OFF`, `ORDER_AMOUNT_OFF`, `FREE_SHIPPING`, `BXGY`, `FREE_SAMPLES`, `X_FOR_Y`, `PRODUCT_FIXED_AMOUNT`, `FREE_SHIPPING_V2`.
*   `percentOff` (_number (double)_)
*   `maxDiscountAmount` (_number (double)_)
*   `maxTotal` (_number_)
*   `amountOff` (_number_)
*   `shippingMethods` (_array of string_)
*   `hasSingleUsePromoCodes` (_boolean_)
*   `imageUrl` (_string_)
*   `discountedQuantity` (_integer (int32)_)
*   `freeSamples` (_array of CombinationGroup_)
*   `merchantPromotionId` (_string_)
*   `amount` (_number_)
*   `promoRules` (_array of PromotionRule_)
*   `qualifyingGroups` (_array of CombinationGroup_)
*   `discountedGroups` (_array of CombinationGroup_)
*   `amountExpression` (_string_)
*   `tierGroups` (_array of TierGroup_)
*   `discountedGroupProration` (_boolean_)
*   `promotionLanguageData` (_array of PromotionLanguageData_) Promotion attributes in additional languages.
*   `bxgyDiscountType` (_string_) Buy X Get Y discount types.  
    Allowed values: `PERCENT_OFF`, `AMOUNT_OFF`, `FIXED_PRICE`.
*   `createdBy` (_string_)
*   `createdOn` (_string (date-time)_)
*   `lastUpdatedOn` (_string (date-time)_)
*   `lastUpdatedBy` (_string_)
*   `promotionMappings` (_array of PromotionMapping_)
*   `isExternallyValidated` (_boolean_)
*   `promotionTypePriority` (_string_)  
    Allowed values: `FREE_SAMPLES`, `BXGY_FIXED_AMOUNT`, `X_FOR_Y`, `BXGY_AMOUNT_OFF`, `BXGY_PERCENT_OFF`, `PRODUCT_FIXED_AMOUNT`, `ORDER_AMOUNT_OFF`, `ORDER_PERCENT_OFF`, `FREE_SHIPPING_V2`, `FREE_SHIPPING`.
*   `promotionCode` (_PromotionCode_)

### Address

Address **Billing Address:** It contains first and last name of billing person. It is applicable if order is associated with signed-in customer or if an order requires billing address. Note: If item level shipping method or item level shipping address is enabled, use the shippingAddress from deliveryGroups. For more details, see:.

*   `salutation` (_string_, nullable) Salutation.
*   `firstName` (_string_) Customer first name saved for address.  
    Maximum length: 64.
*   `secondName` (_string_, nullable) Customer second name saved for address.  
    Maximum length: 64.
*   `lastName` (_string_, nullable) Customer last name saved for address.  
    Maximum length: 64.
*   `suffix` (_string_, nullable) Suffix.
*   `addressLine1` (_string_, required) Address Line 1.  
    Maximum length: 256.
*   `addressLine2` (_string_, nullable) Address Line 2.  
    Maximum length: 256.
*   `city` (_string_, required) City.  
    Maximum length: 64.
*   `state` (_string_, required) State.  
    Maximum length: 32.
*   `postalCode` (_string_, required) Postal Code.  
    Maximum length: 16.
*   `countryCode` (_string_, nullable) Country Code.  
    Maximum length: 32.
*   `phone` (_string_, nullable) Phone.  
    Maximum length: 24.
*   `storeId` (_string_, nullable) Store ID if it is store address.
*   `emailAddress` (_string_, nullable) Customer Email Address.
*   `country` (_string_, nullable) Country.
*   `defaultBilling` (_boolean_)
*   `defaultShipping` (_boolean_)

### LoyaltyInfo

*   `pointsRedeemValue` (_number (double)_)
*   `pointsEarnValue` (_number (double)_)
*   `pointsClosingBalance` (_number (double)_)

### OrderTaxRate

VAT breakup for return items.

*   `countryCode` (_string_, required) Country Code.  
    Maximum length: 2. Example: `US`.
*   `state` (_string_, nullable) State. Applicable if the tax rate is specific to state.  
    Maximum length: 128.
*   `postalCode` (_string_, nullable) Postal Code. Applicable if the tax rate is specific to postal code.  
      
    Maximum length: 10.
*   `taxType` (_string_, required) Indicates the tax type, such as COUNTRY, CITY, or STATE. The following tax types are specific to the Vertex tax engine: PROVINCE, TERRITORY, APO, BOROUGH, FPO, LOCAL\_IMPROVEMENT\_DISTRICT, PARISH, SPECIAL\_PURPOSE\_DISTRICT, TOWNSHIP, TRADE\_BLOCK, and TRANSIT\_DISTRICT.  
    Allowed values: `CLASS`, `CITY`, `DISTRICT`, `COUNTY`, `STATE`, `COUNTRY`, `ITEM_OVERRIDE`, `STORE_OVERRIDE`, `TRANSACTION_OVERRIDE`, `SPECIAL`, `PROVINCE`, `TERRITORY`, `APO`, `BOROUGH`, `FPO`, `LOCAL_IMPROVEMENT_DISTRICT`, `PARISH`, `SPECIAL_PURPOSE_DISTRICT`, `TOWNSHIP`, `TRADE_BLOCK`, `TRANSIT_DISTRICT`.
*   `chargeType` (_string_) Indicates if the charge is for tax or fee - TAX/FEE.  
    Default: `TAX`.
*   `nonRefundable` (_boolean_) Indicates if the charge (tax or fee) is refundable.  
    Default: `false`.
*   `taxRate` (_number (float)_, required) % tax/vat rate.  
    Example: `7.25`.
*   `taxClass` (_string_, required) Tax class corresponding to the tax rate.  
      
    Example: `Tax Class for Shoes and Clothing - PS0001`.
*   `taxCode` (_string_, required) Tax Identifier. Unique identifier for a tax rate. Unique per item.
*   `taxAmount` (_number_, required) Total tax amount for the item corresponding to the tax rate for the order.  
    Example: `7.25`.
*   `taxName` (_string_, required) Tax name, for example, Jurisdiction, MTA, BTW Hoog, or BTW Laag.  
    Maximum length: 64.
*   `displayTaxName` (_string_, required) Display tax name, for example, Jurisdiction - 7.25%, BTW Hoog - 21%, or BTW Laag - 9%.
*   `returnedTaxAmount` (_number_) Sum of returned tax amounts of a particular type (group of TaxType, TaxClass, TaxName, TaxRate) across returned products.
*   `remainingTaxAmount` (_number_) Sum of tax amounts of a particular type(group of TaxType, TaxClass, TaxName, TaxRate) across non-returned products.
*   `corporateTaxId` (_string_, nullable) Print tax name for receipts.  
    Includes the merchant's tax identification number, for example, HST-74252RT0001 - 7.25%.
*   `printTaxName` (_string_, nullable) Print tax name for receipts. Includes merchant's tax identification number. For example: HST-74252RT0001 - 7.25%.
*   `externalTaxId` (_string_, nullable) Additional Tax Identifier for Merchant Systems.
*   `effectiveDate` (_integer (int64)_) Effective date of the current tax rate in epochMillis. Use the epoch values as-is without applying in offset.
*   `subTotal` (_number_, nullable) Sum of product prices excluding the VAT amount. Applicable only for VAT enabled countries because for non VAT countries a product can have two rates applied to it. " Product is not necessarily exclusive to a single tax rate in non VAT scenario.Only Products that fall under particular VAT rate are considered.
*   `total` (_number_, nullable) Sum of product prices including the VAT amount. Applicable only for VAT enabled countries because for non VAT countries a product can have two rates applied to it. Product is not exclusive to a single tax rate in non VAT scenario. Only Products that fall under particular VAT rate are considered.
*   `taxDescription` (_string_, nullable) Tax Description text.
*   `jurisdiction` (_string_, nullable) Jurisdiction.  
    Maximum length: 128.
*   `registrationNumber` (_string_, nullable) Registration Number.  
    Maximum length: 128.
*   `externalId` (_string_, nullable) Identifies the current tax record in the external system. This is a record identifier, not a tax identifier. Used when an order is imported from an external system. Orders placed directly through POS don't populate this identifier. The external system provides this identifier and POS replays it during order posting for subsequent modifications such as returns.  
    Maximum length: 128.

### TaxExemptionRequest

Sale side tax exemptions.

*   `cartId` (_string_, nullable) Cart ID. Backend populates it internally from path param. It is optional for app to provide it if the API endpoint contains the cartId as path param.
*   `customerId` (_string_, nullable) Customer ID.
*   `offlineMode` (_boolean_, nullable) Flag for offline mode.
*   `taxExemptCode` (_string_, required) Tax exemption tax code.  
    Maximum length: 128.
*   `customerName` (_string_, required) Customer name for customer having tax exemption applied.  
    Maximum length: 128.
*   `cardNumber` (_string_, required) Customer tax exemption card number.  
    Maximum length: 64.
*   `notes` (_string_, nullable) Optional notes for tax exemption.  
    Maximum length: 128.
*   `displayTaxName` (_string_) Display Tax Name to be printed on UI.
*   `printTaxName` (_string_) Tax Name to be printed on receipt.
*   `taxExemptionRate` (_number (float)_, required) Tax exemption rate.  
    Example: `7.25`.
*   `taxType` (_string_, nullable) Indicates the tax type, such as COUNTRY, CITY, or STATE. The following tax types are specific to the Vertex tax engine: PROVINCE, TERRITORY, APO, BOROUGH, FPO, LOCAL\_IMPROVEMENT\_DISTRICT, PARISH, SPECIAL\_PURPOSE\_DISTRICT, TOWNSHIP, TRADE\_BLOCK, and TRANSIT\_DISTRICT.  
    Allowed values: `CLASS`, `CITY`, `DISTRICT`, `COUNTY`, `STATE`, `COUNTRY`, `ITEM_OVERRIDE`, `STORE_OVERRIDE`, `TRANSACTION_OVERRIDE`, `SPECIAL`, `PROVINCE`, `TERRITORY`, `APO`, `BOROUGH`, `FPO`, `LOCAL_IMPROVEMENT_DISTRICT`, `PARISH`, `SPECIAL_PURPOSE_DISTRICT`, `TOWNSHIP`, `TRADE_BLOCK`, `TRANSIT_DISTRICT`.
*   `taxExemptName` (_string_, nullable) Tax exemption name.  
    Maximum length: 128.

### Reason

Reason for returning the item.

*   `reasonCodeType` (_string_, required) Type for reason codes. It can be one of TRANSACTION\_DISCOUNT, PRICE\_OVERRIDE, RETURNS, BANK\_DEPOSIT, TILL\_RECONCILIATION, TILL\_CASH\_OUT.  
    Allowed values: `TRANSACTION_DISCOUNT`, `PRICE_OVERRIDE`, `RETURNS`, `BANK_DEPOSIT_VARIANCE`, `TILL_RECONCILIATION_VARIANCE`, `TILL_CASH_OUT`, `PRICE_CORRECTION`, `RETURN_PRICE_CORRECTION`, `EXCLUDE_ITEM_FROM_CYCLE_COUNT`, `INVENTORY_ADJUSTMENT`, `SAFE_FLOAT_UPDATE`, `TILL_FLOAT_UPDATE`, `TILL_CASH_IN`, `TILL_NO_SALE`, `VOID_CART`, `EXPENSE_UPDATE`, `MISC_EXPENSE1_UPDATE`, `MISC_EXPENSE2_UPDATE`, `INVENTORY_ITEM_RECEIVE_MISMATCH`, `OFFLINE_GHOST_TILL`, `DELETE_ITEM`, `CORP_CANCELLATION`, `FULFILLMENT_CANCELLATIONS`. Maximum length: 64.
*   `reasonCode` (_string_, required) Reason code.  
    Maximum length: 64.
*   `reasonText` (_string_, nullable) Reason text.  
    Maximum length: 256.

### ExchangeItemResponse

Details about the items that are being returned or exchanged.

*   `errorMessage` (_string_, nullable) Error message shown to the user.  
    Example: `Invalid request. Please check the request and try again.`.
*   `errorCode` (_string_, nullable) Error code shown to the user.  
    Example: `INTERNAL_ERROR`.
*   `orderId` (_string_)
*   `exchangeStatus` (_string_)  
    Allowed values: `EXCHANGED`, `EXCHANGED_WITH_REFUND`, `FAILED`, `SKIPPED`.
*   `refundAmount` (_number_)
*   `refundMedium` (_string_)
*   `refundStatus` (_string_)
*   `orderStatus` (_string_)
    
    Below is the list of statuses for in-store purchases and BORIS. The statuses are applicable for both the order and its items. The significance of each status is described in detail below.  
    The eligibility of an item for returns is determined by its current status and the status of the order. Moreover, the **returnsEligibility** attribute at the item level (productList, orderProductList) can also be used to regulate the return eligibility of an item.  
    To learn more about returns eligibility, please refer to the table below and orderProductList.returnsEligibility/productList.returnsEligibility  
      
    
    | Order Status | Display Name in Order History Filter | Significance for Order | Significance for Item | Return Eligibility |
    | --- | --- | --- | --- | --- |
    | COMPLETED | Completed | Successful sale transaction. | Item sold successfully. | Both the order and item are eligible for return. |
    | RETURNED | Returned | Successful return or exchange of all items with refund to customer. | Successful return of an item - whole quantity and is not eligible for return. | Both the order and item are not eligible for return. |
    | PARTIALLY\_REFUNDED | Partially Returned | Successful return or exchange of partial items with refund to customer. | Successful return of an item - partial quantity | Further returns are allowed on order as well as on item. |
    | EXCHANGED | Exchanged | Successful transaction that exchanges all items with no refund to customer | Successful exchanges of an item - whole quantity | Both the order and item are not eligible for return. |
    | PARTIALLY\_EXCHANGED | Partially Exchanged | Successful transaction that exchanges partial items with no refund to customer | Successful exchanges of an item - partial quantity | Further returns are allowed on order as well as on item. |
    | FAILED | Failed | Failed sale transaction. | Not applicable | Both the order and item are not eligible for return. |
    | PENDING | Pending | Sale transaction awaiting payment confirmation. For example, Remote Pay By Link | Not applicable | Both the order and item are not eligible for return. |
    
      
    Allowed values: `NEW`, `PROCESSING`, `PARTIALLY_SHIPPED`, `SHIPPED`, `CANCELED`, `COMPLETED`, `FAILED`, `RETURNED`, `PARTIALLY_REFUNDED`, `REWARD`, `PENDING`, `UNKNOWN`, `READY`, `PACK`, `UNPACK`, `PICKED`, `DELIVERED`, `CREATED`, `CANCELLED_WITH_REFUND`, `UNAVAILABLE`, `DAMAGED`, `EXCHANGED`, `PARTIALLY_EXCHANGED`, `RECREATED`, `FULFILLED`, `PENDING_ORDER`, `IN_TRANSIT`, `EDITED`.
*   `products` (_array of Product_)
*   `order` (_CustomerOrder_)
*   `amountPendingRefund` (_number_)
*   `refundPaymentData` (_array of PaymentData_)
*   `refundPaymentDataOriginalTender` (_array of PaymentData_)
*   `paymentData` (_array of PaymentData_)
*   `parentOrderId` (_string_)
*   `noReceiptReturns` (_boolean_)
*   `editOrderId` (_string_)
*   `refundFees` (_array of RefundFee_, nullable) Refund fees charged so far.
*   `transactionId` (_string_, nullable) Transaction identifier to identify current exchange transaction.
*   `offlineMode` (_boolean_) Flag to indicate whether returns or exchange is being performed in offline mode or not.
*   `postProcessingPerformed` (_boolean_) Flag to indicate if the post processing webhook is triggered or not.
*   `paidAmount` (_number_) Used in edit order flow. Amount already paid as part of original order.
*   `orderReturnsPolicy` (_OrderReturnsPolicy_)
*   `employee` (_Employee_)
*   `tipTotal` (_number_) Tip Total to be refunded in case of pure return.
*   `request` (_ExchangeItemRequest_)
*   `refundPerformed` (_boolean_)
*   `returnableItemTotal` (_number_)
*   `paymentDetails` (_array of OrderPaymentDetail_)
*   `exchangeOrderPaymentDetails` (_array of ExchangeOrderPaymentDetail_)
*   `error` (_boolean_)

### ReturnsTender

In case there is refund, refund tender details and options.

*   `returnsTenderId` (_string_)
*   `tenderHeaderText` (_string_)
*   `headerText` (_string_) Display text corresponding to the refund option.
*   `tenders` (_array of PaymentData_)
*   `returnsPolicies` (_array of string_) All the applied returns policies to determine the refund option.  
    Items: Allowed values: `MaxReturnsDays`, `MaxCashReturns`, `RemapRefundTenders`, `StoreCredit`, `GiftCard`, `CustomerNotInPersonRefund`, `CreditCard`, `NoReceiptReturns`, `Check`.
*   `managerOverrideRequired` (_boolean_)
*   `amountToBeCharged` (_number_) Effective amount to be charged to customer based on purchases, any refunds, discounts , taxes, shipping, any additional fee & rounding if any for this return tender.
*   `headerTextForManagerOverride` (_string_, write-only)
*   `approvalPolicyForManagerOverride` (_string_, write-only)  
    Allowed values: `CREATE_TILL`, `MAX_CASH_RETURN_POLICY`, `MAX_RETURN_WINDOW_POLICY`, `NRR`, `TENDER_REMAPPING`, `OFFLINE_MAX_CASH_RETURN_POLICY`, `OFFLINE_MAX_RETURN_WINDOW_POLICY`, `OFFLINE_NRR`, `OFFLINE_TENDER_REMAPPING`, `PAY_IN_OUT`, `EMPLOYEE_SALE`, `LINE_ITEM_DISCOUNT`, `TRANSACTION_DISCOUNT`, `RECONCILE_TILL`, `CASH_PICKUP`, `BUSINESS_CHECK`, `NO_SALE`, `POST_ADJUSTMENT_INVENTORY`, `CYCLE_COUNT_BATCH_SERIALNUMBER`, `SPECIAL_ITEM`, `REUSE_OLD_TILL`, `TAX_MODIFICATION`, `PRICE_CORRECTION`, `SHOW_ASSOCIATE_REVENUE_IN_DASHBOARD`, `VIEW_SAFE_MANAGEMENT`, `VIEW_ALL_TILLS`, `CYCLE_COUNT_LIFECYCLE`, `CYCLE_COUNT_DETAILS`, `VIEW_ALL_CYCLE_COUNT_BATCHES`, `UPDATE_ALL_CYCLE_COUNT_BATCHES`, `MANAGER_OVERRIDE`, `RETURN_EXCHANGE_POLICY`, `CASH_AUDIT`, `APPEASEMENT`, `EDIT_SAFE_MANAGEMENT`, `REMOVE_WARRANTY`.

### OrderNote

The Order level notes.

*   `orderId` (_string_) Order Identifier.
*   `noteId` (_string_, required) Unique Identifier for the Note.  
    Maximum length: 128.
*   `noteText` (_string_, required) Note Text.  
    Maximum length: 1024.
*   `transactionId` (_string_, required) Unique Identifier for the Transaction.  
    Maximum length: 128.
*   `createdBy` (_string_, required) Associate Id of the User who created the Note.  
    Maximum length: 128.
*   `modifiedBy` (_string_, nullable) Associate Id of the User who modified the Note.  
    Maximum length: 128.
*   `createdOn` (_integer (int64)_, required) Creation Date of the Note in epoch milliseconds.
*   `modifiedOn` (_integer (int64)_, nullable) Modification Date of the Note in epoch milliseconds.
*   `merchantId` (_string_)
*   `locale` (_string_)
*   `region` (_string_)

### ExchangeItemRequest

Request for items that are being returned or exchanged.

*   `storeAssociateId` (_string_, required) ID of the store associate who performs the returns.
*   `storeId` (_string_, required) ID of the store where the return is being performed.
*   `installationId` (_string_, required) Installation ID of the register from where the return is being performed.
*   `noReceiptReturns` (_boolean_, nullable) Flag to indicate returns without receipt.  
    Default: `false`.
*   `receiptType` (_string_, nullable) Receipt type enum.  
    Allowed values: `ORDER`, `QUOTE`, `GIFT`, `GIFT_SKU_LEVEL`, `GIFT_REWARD_CARD`, `INVENTORY_TRANSFER_PACKING_SLIP`, `PO_ORDER`, `STORE_TO_STORE_TRANSFER`, `RETURN_TO_VENDOR_TRANSFER`, `PICK_LIST`.
*   `editOrderId` (_string_, nullable) Set in case of edit order mode. Value will be same as orderId.
*   `refundFees` (_array of RefundFee_) Refund fees applied when cancelling or returning items from an order during the edit order flow.
*   `offlineMode` (_boolean_) Flag to indicate whether returns or exchange is being performed in offline mode or not.
*   `returnProducts` (_array of ReturnProductIdentification_) Returning item's orderItemId and quantity.
*   `taxRates` (_array of OrderTaxRate_, nullable) Tax breakup for return items.
*   `vatRates` (_array of OrderTaxRate_, nullable) VAT breakup for return items.
*   `paidAmount` (_number_) Used in edit order flow. Amount already paid as part of original order.
*   `storeAttribution` (_StoreAttribution_)
*   `productPriceAdjustments` (_array of ProductPriceAdjustment_)
*   `employee` (_Employee_)
*   `orderSource` (_string_, nullable) Order Source - Indicates channel from where the order originated.  
    Allowed values: `DEFAULT`, `IN_STORE`, `POPUP_STORE`, `WEB`, `APP`, `OUTLET_STORE`, `ONLINE`, `POS_EA`.
*   `tariffRate` (_number_, nullable) The tariff rate at the time of sale. This value is retrieved from **CMS** > **Store Settings** > **Tariffs and** is included only when the tariff configuration is available in CMS.
*   `tariffAmount` (_number_, nullable) The tariff amount at the time of sale. This value is retrieved from **CMS** > **Store Settings** > **Tariffs** and is included only when the tariff configuration is available in CMS.
*   `giftCardCashOut` (_boolean_)
*   `exchangeOrderPaymentDetails` (_array of ExchangeOrderPaymentDetail_)

### Profile

Customer profile. In case of sale and return transactions, it is mandatory if a signed-in customer places an order or a return. Note: If an order is imported from an external system into POS, only customerId and alternateCustomerId from the profile object are used.

*   `customerId` (_string_, nullable) Customer ID. Optional for guest customer. Mandatory for logged-in customer.
*   `alternateCustomerId` (_string_, nullable) Alternate Customer ID.
*   `email` (_string_, nullable) Customer Email ID.  
    Optional for guest customer. Mandatory for logged-in customer.
*   `salutation` (_string_, nullable) Salutation.
*   `firstName` (_string_, nullable) Customer first name  
    Optional for guest customer. Mandatory for logged-in customer.
*   `secondName` (_string_, nullable) Customer second name.
*   `lastName` (_string_, nullable) Customer last name  
    Optional for guest customer. Mandatory for logged-in customer.
*   `suffix` (_string_, nullable) Suffix.
*   `address` (_object_) Customer address. In requests sent from POS to the merchant system: accepts any customer address (primary, secondary, or other). In responses returned to POS from the merchant system: contains the customer's primary address.
    
    Includes all fields of `Address`.
    
*   `phoneHome` (_string_, nullable) Phone Home.
*   `phoneMobile` (_string_, nullable) Phone Mobile. This is the primary phone number for the customer.
*   `phoneBusiness` (_string_, nullable) Phone Business.
*   `fax` (_string_, nullable) Fax.
*   `birthmonth` (_string_, nullable) Customer birth month. Not applicable for order related scenarios like export/import.
*   `wallets` (_array of Wallet_, nullable) Customer wallets containing tokenized cards for Card on File payments.  
    Optional field returned only when customer has stored cards.
*   `eReceipt` (_boolean_, nullable) Customer eReceipt indicator. Not applicable for order related scenarios like export/import.
*   `country` (_string_, nullable) Country.
*   `customerGroup` (_string_, nullable) Customer group. Not applicable for order related scenarios like export/import.
*   `preferredLanguage` (_string_, nullable) Preferred language. Not applicable for order related scenarios like export/import.
*   `allowSmsNotifications` (_boolean_, nullable) SMS sign up checkbox. Not applicable for order related scenarios like export/import.
*   `loyaltyId` (_string_, nullable) Loyalty Id of the customer.
*   `logoUrl` (_string_, nullable) The URL for the logo to be displayed for loyalty customers. Not applicable for order related scenarios like export/import.

### RefundFee

Refund fees applied when cancelling or returning items from an order during the edit order flow.

*   `id` (_string_) Refund fee ID. For example, Restocking or 001.
*   `label` (_string_) Refund fee display name. For example, Restocking Fee.
*   `value` (_number_, nullable) Refund fee amount.

### TaxTransaction

Details related to tax transaction related to a cart. A cart can be modified multiple times and hence it can be sent to tax engine multiple times. All such requests are tagged under single tax transaction id.

*   `cartId` (_string_) Cart ID related to the current tax transaction.
*   `transactionId` (_string_) Tax transaction ID. Multiple requests to the tax engines related to a cart can be tagged with a single tax transaction ID to group together all tax requests related to a single cart.
*   `editOrderId` (_string_) Order ID for the order being edited.

### OrderLevelGiftWrap

Gift Wrap.

*   `giftWrapMode` (_string_)  
    Allowed values: `ALL_ITEMS_TOGETHER`, `EACH_ITEM_SEPARATELY`.
*   `giftFrom` (_string_)
*   `giftTo` (_string_)
*   `giftMessage` (_string_)

### PaymentInstallment

*   `frequency` (_string_)
*   `count` (_integer (int32)_)
*   `amount` (_number_)
*   `text` (_string_)
*   `installments` (_array of PaymentInstallmentItem_)
*   `amountDueToday` (_number_)

### PaymentInstallmentOptions

List of Payment Installment options available.

*   `shippingMethodId` (_string_)
*   `paymentInstallmentList` (_array of PaymentInstallment_)

### OrderPickUpDetail

List of pick up details for the cart.

*   `orderId` (_string_) Order Identifier.
*   `pickupDetailId` (_string_, required) Unique ID for the order pickup detail. Each pickup item from productList and orderProductList has a reference to this ID.  
    Maximum length: 128.
*   `storeId` (_string_, required) ID of the store from where the items are picked up.  
    Maximum length: 128.
*   `firstName` (_string_, required) First name of the person who is picking up the order.  
    Maximum length: 128.
*   `lastName` (_string_, required) Last name of the person who is picking up the order.  
    Maximum length: 128.
*   `email` (_string_, required) Email of the person who is picking up the order.  
    Maximum length: 128.
*   `phone` (_string_, required) Phone number of the person who is picking up the order.  
    Maximum length: 128.
*   `pickupDate` (_string (date-time)_, nullable) Customer pickup date & time. Used for SLA visibility (BOPIS).
*   `pickupDateTimestamp` (_integer (int64)_, nullable) Customer pickup date & time in epoch milliseconds.
*   `merchantId` (_string_)
*   `locale` (_string_)
*   `region` (_string_)

### Tender

Tender object with payment details.

*   `errorMessage` (_string_, nullable) Error message shown to the user.  
    Example: `Invalid request. Please check the request and try again.`.
*   `errorCode` (_string_, nullable) Error code shown to the user.  
    Example: `INTERNAL_ERROR`.
*   `paymentSequenceNumber` (_integer (int32)_, required) Payment sequence indicating the order of payment. For example, if customer pays partially with cash first and remaining with credit card, then cash tender should have paymentSequenceNumber as 1 and credit card tender should have paymentSequenceNumber as 2.
*   `paymentMethod` (_string_, required) Identifies the payment method.  
    Allowed values: `Cash`, `CreditCard`, `GiftCard`, `PLCC`, `Check`, `ACH`, `Miscellaneous`, `ApplePay`, `AndroidPay`, `Finance`, `RewardCard`, `PayPal`, `StoreCredit`, `CreditCard_Visa`, `CreditCard_MasterCard`, `CreditCard_Amex`, `CreditCard_Discover`, `eGiftCard`, `WeChatPay`, `AliPay`, `PayByLink`, `RemotePayByLink`, `Installments`, `Reward`, `GooglePay`, `Affirm`, `Afterpay`.
*   `paymentDevice` (_string_, required) Identifies the payment device through which the payment is made. If payment data is manually entered, this field should be set to NoReader. If payment is made in an external system, payment device should be set to External.  
    Allowed values: `Adyen`, `PayPal`, `VerifonePSDK`, `Square`, `CheckReader`, `NoReader`, `External`, `StoredCard`, `Stripe`, `Elavon`, `Aurus`.
*   `amountAuthorized` (_number_, required) Amount paid using this tender.
*   `rawPaymentPayload` (_string_) Raw payment payload. For future use.
*   `routingNumber` (_string_) Bank routing number.
*   `accountNumber` (_string_) Account number. Used for payment through banking system.
*   `checkNumber` (_string_) Check number. Used for payment through checks.
*   `personalIdType` (_string_) Personal identification type.  
    Allowed values: `DriversLicense`, `StateID`, `MilitaryID`, `Passport`, `StudentID`, `PermanentResidentID`, `TribalID`, `BusinessPhone`.
*   `personalIdIssuedBy` (_string_) Issuer of the personal identification.
*   `personalIdNumber` (_string_) Personal identification number.
*   `personalIdExpiryDateMillis` (_integer (int64)_) Personal identification expiry date represented as milliseconds since epoch. Typically expiry date is end of the day and milliseconds since epoch should reflect it accordingly.
*   `cardNumber` (_string_) Card number. Could be either partial (last 4 digits) or complete card number (in case of manual credit card data entry).
*   `cardBin` (_string_, nullable) Card BIN (Bank Identification Number) - first 6 or 8 digits of the card number.
*   `cardCvc` (_string_) Card CVC. Used in case of manual credit card data entry.
*   `track1Data` (_string_) Encrypted track1 data. Used in case of client/app side card encryption by readers like Verifone.
*   `track2Data` (_string_) Encrypted track2 data. Used in case of client/app side card encryption by readers like Verifone.
*   `paymentDeviceId` (_string_) Unique identifier like serial number for payment reader. Used in case of client/app side card encryption by readers like Verifone.
*   `operatingMode` (_string_) Operating mode of the app and card reader - ONLINE/OFFLINE. Other values are unused.  
    Allowed values: `ONLINE`, `OFFLINE`, `DEGRADED`, `TWO_PHASE_STAGING`.
*   `encryptedExpiryDate` (_string_) Encrypted expiry date. Used in case of client/app side card encryption by readers like Verifone.
*   `encryptedCardNumber` (_string_) Encrypted card number. Used in case of client/app side card encryption.
*   `encryptedCvv` (_string_) Encrypted card CVV. Used in case of client/app side card encryption.
*   `cardToken` (_string_) This is the tokenized value for payments made via Credit Card, Pay By Link, or Remote Pay By Link. Please note that tokenization is only supported for Adyen and must be configured in the CMS (**CMS** > **Integration** > **Payment Gateways** > **Adyen** > **Payment Tokenization Events**).
*   `storedCardId` (_string_) Stored Card ID to use in case of card stored for the customer profile.
*   `cardType` (_string_) Card type. For example, Visa, Master, Amex, or Discover.
*   `rawCardType` (_string_) Raw card type, for example, Visa Credit Card, Visa Debit Card, or Master Credit Card. Typically used when an Adyen terminal captures card data for payment.
*   `cardExpirationMonth` (_integer (int32)_) Card expiry month.
*   `cardExpirationYear` (_integer (int32)_) Card expiry year.
*   `pin` (_string_) PIN number typically used for gift card.
*   `authorizationToken` (_string_) Payment authorization token.
*   `authorizationDateMillis` (_integer (int64)_) Payment authorization timestamp as number of milliseconds since epoch.
*   `captureToken` (_string_) Payment capture token.
*   `captureDateMillis` (_integer (int64)_) Payment capture timestamp as number of milliseconds since epoch.
*   `requestId` (_string_) Payment request identification issued by payment gateway/terminal. Typically used for referenced refunds. This field maps to pspReference in case of Adyen payments.
*   `alternateRequestId` (_string_) Alternate payment request identification issued by payment terminal. Example, tender reference in case of Adyen terminal is in store and forward mode.
*   `requestToken` (_string_) Payment request token issued by payment gateway/terminal. Typically used for referenced refunds.
*   `firstName` (_string_) First name to use for billing using this tender.
*   `lastName` (_string_) Last name to use for billing using this tender.
*   `addressLine1` (_string_) Address line 1 to use for billing using this tender.
*   `addressLine2` (_string_) Address line 2 to use for billing using this tender.
*   `city` (_string_) City to use for billing using this tender.
*   `state` (_string_) State to use for billing using this tender.
*   `postalCode` (_string_) Postal code to use for billing using this tender.
*   `country` (_string_) Country code to use for billing using this tender.
*   `paypalInvoiceId` (_string_) Invoice ID. Used when payment is done using paypal reader.
*   `externalPaymentSystemId` (_string_) External payment system identifier in case of External tender.
*   `externalPaymentReferenceId` (_string_) External payment reference identifier in case of External tender.
*   `paymentGatewayConfigId` (_string_) Payment Gateway ID - to be used in case of multiple payment gateways are available to process a single tender.
*   `receiptLines` (_array of PaymentReceiptLine_) Receipt lines. For information to be shown on receipt.
*   `merchantReferenceId` (_string_) Merchant reference ID sent to the payment terminal for this tender. This is required for match response received off asynchronously from payment processor (like Adyen Store and Forward) with the correct payment object for an order.
*   `paymentStatus` (_string_) Payment status. UNPROCESSED is used internally by cloud services as a transient state. DISCARDED is used when cash tender is in multi-tender and deleted by swiping right. ABORTED is used where we internally remove tender from our tender list and add a new tender, for example, gift card.  
    Allowed values: `UNPROCESSED`, `APPROVED`, `PENDING`, `DECLINED`, `CANCELED`, `REVERTED`, `REVERSAL_FAILURE`, `UNKNOWN`, `NOT_FOUND`, `NOT_APPLICABLE`, `ABORTED`, `DISCARDED`, `FAILED`, `UNVERIFIED`, `EXPIRED`, `SAF_DECLINED`, `SAF_UNKNOWN`.
*   `checkType` (_string_) Type of the check - Personal or Business.  
    Allowed values: `Personal`, `Business`.
*   `manualAuthorizationCode` (_string_) Manual authorization code for a tender. Normally it is received after calling a call center agent of a payment processor. For example, call for auth code after check denial/referral, manual auth code for credit card when offline.
*   `paymentTypeCode` (_string_) Type of payment plan. Used for Tender Type - Finance.
*   `cardPresent` (_boolean_) Indicates if the card is physically present or not. Used in case of Tender Type - Finance.
*   `ssn` (_string_) Customer's Social Security Number for verification purposes. Used in case of Tender Type - Finance.
*   `accountHolders` (_array of AccountHolder_) Account Holders information. Used in case of Tender Type - Finance.
*   `additionalInfo` (_array of string_) List of additional information required to verify the buyer. Used in case of Tender Type - Finance.
*   `cashDrawerUrl` (_string_) Represents custom URL using which cash drawer in the network can be accessed.
*   `roundingAmount` (_number_) The delta amount because of rounding.
*   `authStatus` (_string_) Auth status of Credit card payment.  
    Allowed values: `PRE_AUTH`, `AUTH`, `SALE`, `VOID`, `VOID_FAILED`.
*   `tip` (_number_) Tip amount to capture on credit card.
*   `captureStatus` (_string_) Capture status of authorized amount.  
    Allowed values: `CAPTURED`, `CAPTURE_FAILED`, `NON_CAPTURED`, `PARTIALLY_CAPTURED`, `VOID`, `VOID_FAILED`.
*   `financeOrderNo` (_string_) Refers to finance approval/order/confirmation number in external system.
*   `financeInstruction` (_string_) Refers to finance processing related result or instruction long text from external system.
*   `primaryAccountHolder` (_string_) Primary owner on the account.
*   `tradeType` (_string_) Trade Type. In case of WeChatPay: QuickPay.
*   `bankType` (_string_) Bank Type.
*   `fundingSource` (_string_) Funding source like PREPAID.  
    Allowed values: `CHARGED`, `CREDIT`, `DEBIT`, `PREPAID`, `DEFFERED_DEBIT`, `PREPAID_RELOADABLE`, `PREPAID_NONRELOADABLE`, `STORE_VALUE`, `EBT`, `ALTERNATE_TYPE`, `CHECK`, `MOBILE`, `CASH`.
*   `paymentLink` (_string_) Payment Link.
*   `paymentLinkExpiryDate` (_string_) Payment Link expiry date.
*   `paymentId` (_string_) Payment Id from app.
*   `transactionId` (_string_) The transactionId from app's requestId.
*   `paymentReversalStatus` (_string_) Payment Status. UNPROCESSED is used internally by cloud services as a transient state. DISCARDED is used when cash tender is in multi tender and delete by swiping right, ABORTED is used where we internally remove tender from our tender list and add a new tender for eg gift card.  
    Allowed values: `UNPROCESSED`, `APPROVED`, `PENDING`, `DECLINED`, `CANCELED`, `REVERTED`, `REVERSAL_FAILURE`, `UNKNOWN`, `NOT_FOUND`, `NOT_APPLICABLE`, `ABORTED`, `DISCARDED`, `FAILED`, `UNVERIFIED`, `EXPIRED`, `SAF_DECLINED`, `SAF_UNKNOWN`.
*   `captureAmount` (_number_) Amount captured for credit card.
*   `requestTokenExpireDate` (_integer (int64)_) Request token expire date.
*   `continueOnPendingOrDecline` (_boolean_) Continue order processing on tender pending or decline status.
*   `termsAndConditions` (_string_) Terms and conditions.
*   `gcBalance` (_number_, nullable) Balance remaining in case of tender type gift card.
*   `cashTenderedAmount` (_number_, nullable) The cash amount tendered for this transaction.
*   `cashChangeAmount` (_number_) The remaining change amount in case of cash tender.
*   `cardAlias` (_string_, nullable) Card alias provided in the payment response by gateway. In adyen - a value that uniquely represents the shopper's card number (PAN).
*   `paymentEntryMode` (_string_) Indicates how the payment was captured, as provided by the app (for example, VERIFIED\_CARD\_ON\_FILE). The verification is performed on the app side. Used for reporting and audit purposes.
*   `manualCardEntry` (_boolean_)
*   `error` (_boolean_)

### CartSummary

Payload that contains summary of cart totals.

*   `saleSummary` (_TransactionSummary_)
*   `refundSummary` (_TransactionSummary_, required)
*   `netSummary` (_TransactionSummary_, required)
*   `depositSummary` (_TransactionDeposit_)

### Discount

Transaction discount applied on the cart with information like discount type and discount value. In online mode it is copied from app's request payload for transaction discount and in case of offline mode it is copied from app's submit order request.

*   `discountType` (_string_, nullable) Discount types 1. Amount: Item price or transaction-total reduced by provided amount, 2. PERCENT: Item price or transaction-total reduced by amount calculated based on provided percentage and item price/transaction-total, 3. FLAT\_PRICE: Item price is reduced to the provided amount. Not applicable to transaction discounts. The discount amount is then calculated by subtracting entered flat\_price from item-price.  
    Allowed values: `AMOUNT`, `PERCENT`, `FLAT_PRICE`, `AMOUNT, PERCENT`. Default: `AMOUNT`.
*   `discount` (_number_, required) Discount either in percentage or in amount.

### Employee

Employee information. It is applicable for orders with employee discount.

*   `employeeId` (_string_, required) Identification of employee.  
    Maximum length: 128.
*   `firstName` (_string_, required) Employee's first name.  
    Maximum length: 128.
*   `lastName` (_string_, nullable) Employee's last name.  
    Maximum length: 128.
*   `email` (_string_, nullable) Employee's email.  
    Maximum length: 128.
*   `promotionIdList` (_array of string_, nullable) List of promotion IDs valid for the employee.
*   `merchantPromotionIdList` (_array of string_, nullable) List of merchant promotion IDs valid for the employee.
*   `approvingEntity` (_ApprovingEntity_)

### Flash

Generic field for display messages. The display message is populated to provide helpful information to user. One of the use cases is eligible coupon code which is not applied.

*   `type` (_string_, required) Type of the flash message.  
    Allowed values: `PROMOTION`, `TAX`, `TRANSACTION_DISCOUNT`, `PRICE_OVERRIDE`, `RETURN`, `ORDER`, `GIFTCARD`, `CART`, `INVENTORY_RESTRICTION`. Example: `PROMOTION`.
*   `message` (_string_, required) Flash message.  
    Example: `Coupons Spring2023, Max100 are in the cart but not applied`.
*   `resourceName` (_string_, required) Resource or entity for which the message is provided.  
    Allowed values: `COUPON_CODE`, `CART`. Example: `COUPON_CODE`.
*   `resourceValues` (_array of string_, required) Resource values for which the message is provided.  
    Items: Example: `Coupon codes - Spring2023, Max100 etc...`. Example: `Coupon codes - Spring2023, Max100 etc...`.

### AuxiliaryItemData

auxiliary Items details support for edit order.

*   `orderItemId` (_string_) Order item ID.
*   `itemAction` (_string_) Items Action.  
    Allowed values: `NEW`, `MODIFY`.

### CustomerLoyaltyProfile

The loyalty profile of the customer if they are enrolled in Loyalty program.

*   `loyaltyId` (_string_) Loyalty Id of the customer.
*   `firstName` (_string_) Customer's first name.
*   `lastName` (_string_) Customer's last name.
*   `accountNumber` (_string_) Customer's loyalty account number.
*   `loyaltyStatusCode` (_string_, nullable) Customer's loyalty status code.
*   `currentPoints` (_integer (int32)_, nullable) Customer's current loyalty points. If provided, it will be used for validation against the individual reward points (If points are sent in reward).
*   `currentStoreCredit` (_number (double)_, nullable) Customer's current store credit.
*   `lifetimePoints` (_integer (int32)_, nullable) Loyalty point accumulated so far by the customer.
*   `nextRewardPoints` (_integer (int32)_, nullable) Loyalty point eligible for next reward cycle.
*   `transactions` (_Transactions_)
*   `rewards` (_array of Reward_, nullable) Earned rewards.
*   `tierLevelLabel` (_string_, nullable) Customer's tier level label.
*   `tierLevelValue` (_string_, nullable) Customer's tier level value.
*   `tierLevelCode` (_string_, nullable) Customer's tier level code.
*   `redemptionType` (_string_)
*   `internalMemberId` (_string_, nullable) Customer's internal member ID.
*   `homePhoneNumber` (_string_, nullable) Customer's home phone number.
*   `mobilePhoneNumber` (_string_, nullable) Customer's mobile phone number.
*   `address` (_Address_)
*   `currentTier` (_Tier_)
*   `nextTier` (_Tier_)
*   `customLoyaltyAttributes` (_CustomAttributes_)
*   `totalRewardsAmount` (_number_, nullable) Total amount value of all the rewards available for the customer. If provided, this will be used for validation when applying the individual rewards.
*   `loyaltyIdBarCodeType` (_string_)

### ReturnCustomerInformation

Return - Customer Information. For return or exchange transactions, use this object to capture information about the person returning the items. Note: This might or might not be the actual customer who purchased the items. This object is exclusively to capture information about the person returning items.

*   `firstName` (_string_, nullable) First Name.
*   `lastName` (_string_, nullable) Last Name.
*   `phone` (_string_, nullable) Phone.  
    Maximum length: 24.
*   `email` (_string_, nullable) Email ID.
*   `address` (_Address_)
*   `personalId` (_PersonalID_)

### DeltaCart

*   `scale` (_integer (int32)_)
*   `roundingMode` (_string_)  
    Allowed values: `UP`, `DOWN`, `CEILING`, `FLOOR`, `HALF_UP`, `HALF_DOWN`, `HALF_EVEN`, `UNNECESSARY`.
*   `transactionId` (_string_)
*   `transactionTimeStamp` (_integer (int64)_)
*   `storeAttribution` (_StoreAttribution_)
*   `transactionType` (_string_)  
    Allowed values: `SALE`, `RETURN`, `EXCHANGE`, `EDIT`, `EDIT_SALE`, `EDIT_REFUND`.
*   `orderId` (_string_)
*   `productList` (_array of Product_)
*   `cancelProductList` (_array of Product_)
*   `productPriceAdjustmentList` (_array of ProductPriceAdjustment_)
*   `tenderList` (_array of Tender_)
*   `refundTenderList` (_array of RefundTender_)
*   `pickUpDetailList` (_array of OrderPickUpDetail_)
*   `reducedTaxAfterPriceAdjustment` (_number_)
*   `fulfillmentTypeChangeProductList` (_array of Product_)
*   `fulfillmentTypeChangeCancelProductList` (_array of Product_)
*   `secondaryProductList` (_array of Product_)
*   `deliveryGroupChangeList` (_array of ProductDeltaDeliveryGroup_)
*   `deliveryGroupList` (_array of DeliveryGroup_)
*   `secondaryDeliveryGroupList` (_array of DeliveryGroup_)
*   `updatedDeliveryGroupList` (_array of DeliveryGroup_)
*   `summary` (_CartSummary_)
*   `originalProductDeliveryGroupList` (_array of ProductDeliveryGroup_)
*   `notesList` (_array of DeltaOrderNote_)
*   `detailNotesList` (_array of DeltaOrderDetailNote_)
*   `removedDeliveryGroupList` (_array of DeliveryGroup_)
*   `productPickUpDetailList` (_array of ProductPickUpDetail_)

### ProductTax

Product tax details. Mandatory for tax/vat countries and applies to products that are subject to taxation.

*   `totalTax` (_number_, nullable) Total tax. Applicable for tax countries and if the item is taxable.
*   `taxExemption` (_number_, nullable) Tax Exemption. Applicable for tax countries and if the item is taxable but then the tax exemption is applied.
*   `taxRates` (_array of ProductTaxRate_, nullable) Tax rate breakdown for the item. Applicable for tax countries and taxable items. Optional when importing an order from an external system. Used to display the tax breakdown on printed receipts and order history screens. If not provided, the breakdown will not be displayed.
*   `vatRates` (_array of ProductTaxRate_, nullable) VAT rate breakdown for the item. Applicable for VAT countries and taxable items. Optional when importing an order from an external system. Used to display the VAT breakdown on printed receipts and order history screens. If not provided, the breakdown will not be displayed.
*   `valueAddedTax` (_number_, nullable) Total value added tax, Required in case of VAT countries.
*   `taxableAmount` (_number_, required) Taxable amount.

### Store

Pickup location - POS enables the store to place an order in one store and allow the customer to pick up the order from another store (i.e., IN\_STORE/SHIP\_TO\_STORE). In such a case, pickup store information is maintained here.

*   `storeId` (_string_, required) Store ID field to be provided by app.
*   `name` (_string_, required) Store name.
*   `addressLine1` (_string_, required) Store Address Line1.
*   `addressLine2` (_string_, nullable) Store Address Line2.
*   `city` (_string_, required) City.
*   `state` (_string_, required) State.
*   `postalCode` (_string_, nullable) Postal code. Mandatory if the store is configured in CMS with postal code.
*   `countryCode` (_string_, required) Country Code.
*   `email` (_string_, nullable) Store's email ID. Mandatory if the store is configured in CMS with email ID.
*   `phone` (_string_, nullable) Store's phone. Mandatory if the store is configured in CMS with phone.
*   `fax` (_string_, nullable) Store's fax. Mandatory if the store is configured in CMS with fax.
*   `hours` (_array of Hours_, nullable) Store's operational hours. Mandatory if the store is configured in CMS with operational hours.
*   `latitude` (_number (double)_, nullable) Store's latitude. Mandatory if the store is configured in CMS with latitude.
*   `longitude` (_number (double)_, nullable) Store's longitude. Mandatory if the store is configured in CMS with longitude.
*   `storeType` (_string_, nullable) Store type.  
    Allowed values: `Regular`, `Popup`, `Outlet`, `Ecomm`, `Warehouse`, `DistributionCenter`, `Vendor`. Default: `Regular`.
*   `timeZoneId` (_string_, nullable) Store's timezone ID. Mandatory if the store is configured in CMS with timezone ID.
*   `storeGroupID` (_string_)

### AdditionalCharge

*   `display` (_string_)
*   `value` (_number_)
*   `sku` (_string_)
*   `taxable` (_boolean_)
*   `linkedProductId` (_string_)
*   `price` (_number_)
*   `quantity` (_integer (int32)_)
*   `orderItemId` (_string_)
*   `transactionId` (_string_)

### OrderDetailNote

List of notes/comments captured at product level during order submission. If the notes are provided when importing an order from an external system, they will be available for store associate in order history screen of POS App.

*   `orderId` (_string_) Order Identifier.
*   `noteId` (_string_, required) Unique Identifier for the Note.  
    Maximum length: 128.
*   `noteText` (_string_, required) Note Text.  
    Maximum length: 1024.
*   `transactionId` (_string_, required) Unique Identifier for the Transaction.  
    Maximum length: 128.
*   `createdBy` (_string_, required) Associate Id of the User who created the Note.  
    Maximum length: 128.
*   `modifiedBy` (_string_, nullable) Associate Id of the User who modified the Note.  
    Maximum length: 128.
*   `createdOn` (_integer (int64)_, required) Creation Date of the Note in epoch milliseconds.
*   `modifiedOn` (_integer (int64)_, nullable) Modification Date of the Note in epoch milliseconds.
*   `orderItemId` (_string_, required) Order Item Id of the product for which the note is added.  
    Maximum length: 128.
*   `merchantId` (_string_)
*   `locale` (_string_)
*   `region` (_string_)

### OrderStoreAssociateAttribution

Sales associate attribution.  
If not provided, POS attributes the item to the logged-in store associate.  

*   `orderId` (_string_) Order Identifier.
*   `orderItemId` (_string_)
*   `storeId` (_string_)
*   `storeAssociateId` (_string_)
*   `contributionPercentage` (_number_)
*   `attributionNote` (_string_)
*   `firstName` (_string_)
*   `lastName` (_string_)
*   `merchantId` (_string_)
*   `locale` (_string_)
*   `region` (_string_)

### CyoDetails

Payload for CYO - Create Your Own. It is used in multiple use cases like Alterations, DYO, Special Item and Fluid.

*   `type` (_string_, required) Type of customization applied on the product.  
    Allowed values: `Fluid`, `ALTERATIONS`, `DYO`, `SPECIAL_ITEM`, `Fluid, ALTERATIONS, DYO, SPECIAL_ITEM`.
*   `id` (_string_, required) Customization Identification.
*   `payload` (_string_, required) Customization payload containing details specific to the modifications.
*   `customizeUrl` (_string_, nullable) URL for the page or image having finalized customization.
*   `attributes` (_array of CustomField_, nullable) Custom Field.
*   `price` (_number_, required) Customization Price.

### DateTimeSlot

Backup delivery date if slots are unavailable. Default can be set via 'deliveryDatePickerWillCall' in Store settings.

*   `slotId` (_string_) Slot ID.  
    Example: `1234`.
*   `slotDate` (_integer (int64)_, required) Delivery date in epoch.
*   `selectedTimeSlot` (_string_, required) Time slot.  
    Example: `09:00 - 12:00`.
*   `dateTimeSlotType` (_string_, nullable) Time slot type.  
    Allowed values: `Delivery`, `Pickup`. Default: `Delivery`.

### OrderDetailPriceCorrection

If price correction is enabled, the manager can correct the price of the  
item during checkout. The information like original price, approving manager id is  
maintained here after price correction is applied.

*   `orderId` (_string_) Order Identifier.
*   `orderItemId` (_string_, required) Order Item Identifier.  
    Maximum length: 128.
*   `originalPrice` (_number_, required) Original price of the item.
*   `approvingManagerId` (_string_, required) ID of the store manager who has approved the price correction request.  
    Maximum length: 128.
*   `merchantId` (_string_)
*   `locale` (_string_)
*   `region` (_string_)

### ProductFormAttribute

Details about a product form attribute.

*   `key` (_string_) The identifier of the attribute.  
    Example: `color`.
*   `value` (_string_) The value associated with the key.  
    Example: `blue`.

_Example_

```
[
  {
    "key": "color",
    "value": "red"
  }
]
```

### SerializedUnitDetail

Attributes for each individual unit of the product, for example, activation code or context code.

*   `activationCode` (_string_) The activation code of the serialized unit detail.
*   `contextCode` (_string_) The context code of the serialized unit detail.
*   `orderItemId` (_string_) The order item id of the serialized unit detail.

### PriceAdjustment

Price adjustments after applying shipping level promotion. Supported PriceAdjustmentType is PROMOTION only.

*   `description` (_string_, nullable) The price adjustment description will display the promotion name for coupon codes and the reason text for transaction discounts and price overrides. While importing an order from an external system, it is optional.  
    Maximum length: 1500.
*   `adjustment` (_string (-XX.XXX or XX.XXX)_) The discount amount for display purposes. It will be negative for sold items and shipping charges and positive for returned items.  
    Example: `-155.5`.
*   `price` (_number (-XX.XXX or XX.XXX)_) The discount amount. It will be negative for sold items and shipping charges and positive for returned items.  
    Example: `-155.5`.
*   `id` (_string_) Price adjustment ID. In case of promotions, it is promotion ID. For price override and transaction discount, it is GUID.
*   `priceAdjustmentType` (_string_) Price adjustment type.  
    Allowed values: `PRICE_OVERRIDE`, `PROMOTION`, `FEES`, `REWARDS`, `TRANSACTION_DISCOUNT`.
*   `auto` (_boolean_, nullable) Specifies whether the promotion is automatically applied or not. Applicable only for promotions.
*   `fulfillmentType` (_string_)  
    Allowed values: `IN_STORE`, `ONLINE`, `MIXED_CART`.
*   `promoCode` (_string_, nullable) Promotion code provided by customer to apply specific promotion. Applicable only for promotions.
*   `merchantPromotionId` (_string_, nullable) External promotion ID corresponding applied promotion.  
    It is used to identify the promotion in external system and is relevant  
    only if it is configured in CMS  
    Applicable only for promotions.
*   `reasons` (_array of Reason_, read-only, nullable) List of reasons pertaining to the price adjustment. Applicable only for PRICE\_OVERRIDE or TRANSACTION\_DISCOUNT.
*   `quantity` (_integer (int32)_, read-only, nullable) Applicable only for Product level Promotion price adjustments.
*   `discountValue` (_number_, nullable) Applicable only for PRICE\_OVERRIDE OR TRANSACTION\_DISCOUNT.It will hold discount value either in percentage or in amount format.
*   `discountType` (_string_, nullable) Discount types 1. Amount: Item price or transaction-total reduced by provided amount, 2. PERCENT: Item price or transaction-total reduced by amount calculated based on provided percentage and item price/transaction-total, 3. FLAT\_PRICE: Item price is reduced to the provided amount. Not applicable to transaction discounts. The discount amount is then calculated by subtracting entered flat\_price from item-price.  
    Allowed values: `AMOUNT`, `PERCENT`, `FLAT_PRICE`.
*   `rewardId` (_string_, nullable) The ID of the loyalty reward discount. Applicable only for loyalty coupons and loyalty discounts.
*   `rewardName` (_string_, nullable) The name of the loyalty reward discount. Applicable only for loyalty coupons and loyalty discounts.
*   `externalId` (_string_, nullable) This identifier is used when an order is imported from an external system. If an order is placed directly in the POS, this identifier will not be available. The external system provides this identifier, which will then be replayed to that external system during order posting for any subsequent modifications like returns.  
    Maximum length: 128.
*   `adjustmentAmount` (_number_)
*   `referenceAdjustmentId` (_string_)
*   `referenceAdjustmentID` (_string_, write-only)
*   `adjustmentType` (_string_)  
    Allowed values: `PRICE_OVERRIDE`, `PROMOTION`, `FEES`, `REWARDS`, `TRANSACTION_DISCOUNT`.
*   `reasonText` (_string_)

### ProductTaxRate

VAT breakdown for the shipping cost. Applicable for VAT countries and if the shipping cost is taxable.

*   `countryCode` (_string_, required) Country Code.  
    Maximum length: 2. Example: `US`.
*   `state` (_string_, nullable) State. Applicable if the tax rate is specific to state.  
    Maximum length: 128.
*   `postalCode` (_string_, nullable) Postal Code. Applicable if the tax rate is specific to postal code.  
    Maximum length: 10.
*   `taxType` (_string_, required) Indicates the tax type, such as COUNTRY, CITY, or STATE. The following tax types are specific to the Vertex tax engine: PROVINCE, TERRITORY, APO, BOROUGH, FPO, LOCAL\_IMPROVEMENT\_DISTRICT, PARISH, SPECIAL\_PURPOSE\_DISTRICT, TOWNSHIP, TRADE\_BLOCK, and TRANSIT\_DISTRICT.  
    Allowed values: `CLASS`, `CITY`, `DISTRICT`, `COUNTY`, `STATE`, `COUNTRY`, `ITEM_OVERRIDE`, `STORE_OVERRIDE`, `TRANSACTION_OVERRIDE`, `SPECIAL`, `PROVINCE`, `TERRITORY`, `APO`, `BOROUGH`, `FPO`, `LOCAL_IMPROVEMENT_DISTRICT`, `PARISH`, `SPECIAL_PURPOSE_DISTRICT`, `TOWNSHIP`, `TRADE_BLOCK`, `TRANSIT_DISTRICT`.
*   `chargeType` (_string_) Indicates if the charge is for tax or fee - TAX/FEE.  
    Allowed values: `TAX`, `FEE`. Default: `TAX`.
*   `nonRefundable` (_boolean_) Specifies whether the charge (tax or fee) is refundable.  
    Default: `false`.
*   `taxRate` (_number (float)_, required) % tax/vat rate.  
    Example: `7.25`.
*   `taxClass` (_string_, required) The tax engine uses tax classes to apply specific tax rates to different product categories. Each product is linked to a tax class, which determines its applicable tax rate.  
    Example: `Tax Class for Shoes and Clothing - PS0001`.
*   `taxCode` (_string_, required) Unique identifier for a tax rate, unique per item.
*   `taxAmount` (_number_, required) Total tax amount for the item corresponding to the item's tax rate.  
    Example: `7.25`.
*   `perUnitTaxAmount` (_number_, required) Per unit tax amount of the item corresponding to the tax rate.  
    Example: `1.25`.
*   `taxName` (_string_, required) Tax name, for example, Jurisdiction, MTA, BTW Hoog, or BTW Laag.  
    Maximum length: 64.
*   `displayTaxName` (_string_, required) Display tax name, for example, Jurisdiction - 7.25%, BTW Hoog - 21%, or BTW Laag - 9%.
*   `corporateTaxId` (_string_, nullable) Merchant's Tax Identification Number.  
    Example: `HST-74252RT0001`.
*   `printTaxName` (_string_, nullable) Print tax name for receipts. Includes merchant's tax identification number. For example: HST-74252RT0001 - 7.25%.
*   `externalTaxId` (_string_, nullable) Additional Tax Identifier for external systems.
*   `isExempt` (_boolean_, nullable) Indicates if tax is exempted.  
    Default: `false`.
*   `taxDescription` (_string_, nullable) Tax Description text.
*   `jurisdiction` (_string_, nullable) Jurisdiction.  
    Maximum length: 128.
*   `registrationNumber` (_string_, nullable) Registration Number.  
    Maximum length: 128.
*   `externalId` (_string_, nullable) Identifies the current tax record in the external system. This is a record identifier, not a tax identifier. Used when an order is imported from an external system. Orders placed directly through POS don't populate this identifier. The external system provides this identifier and POS replays it during order posting for subsequent modifications such as returns.  
    Maximum length: 128.

### ItemLevelCharge

Item level breakdown for the shipping cost and shipping discount.

*   `orderItemId` (_string_, required) Unique sequence number assigned to cart item that belongs to the order or delivery group.  
    Example: `It can have values like 1, 2, 3, etc...<br> which represents line item number within the order or Delivery Group.`.
*   `itemShippingCharge` (_number_) Item level shipping charge.
*   `itemShippingDiscountAmount` (_number_, nullable) Shipping discount that can be applied on item level shipping price due to promotion or reward.
*   `discountText` (_string_, nullable) Discount text of an applied promotion.  
    Maximum length: 1500.
*   `promotionId` (_string_, nullable) External Merchant promotion ID corresponding applied promotion.

### Message

*   `message` (_string_)
*   `code` (_string_)
*   `type` (_string_)  
    Allowed values: `ERROR`, `WARN`, `INFO`.

### FeedSource

*   `feedType` (_string_)  
    Allowed values: `PRODUCT`, `PRODUCT_BUNDLE`, `STORE`, `LAYOUT`, `PRODUCT_PROMOTION`, `PRODUCT_CATEGORY`, `PRODUCT_CATEGORY_PROMOTION`, `PROMOTION`, `STORE_INVENTORY_FULL`, `STORE_INVENTORY_DELTA`, `SOCIAL_MEDIA`, `ONE_TIME_PROMOTION_CODE`, `PRODUCT_DELTA`, `CATEGORY`, `ORDER_LIST`, `ORDER_DETAILS`, `RECOMMENDATION`, `TAX_RATE`, `PIPELINE`, `STORE_ASSOCIATES`, `PREDICTSPRING_PROMOTION`, `REWARD`, `CASH_REWARD`, `ASN`, `CORP_TRANSFER`, `POS_PROVISIONING`, `SYNONYM`, `STORE_AREA_GOAL`, `STORE_AREA_HIERARCHY`, `OMS`, `PRODUCT_PRICING`, `PRODUCT_SIZING`, `PRODUCT_INVENTORY`, `PRODUCT_PRICING_DELTA`, `PRODUCT_SIZING_DELTA`, `PRODUCT_INVENTORY_DELTA`, `STORE_DEVICE`, `BOPIS_CANCEL_ORDER`, `PURCHASE_ORDER`, `OFFLINE_PROMOTION`, `PREDICTSPRING_PROMOTION_V2`, `EXPIRED_PAYMENT_LINK_CLEANUP`, `SINGLE_USE_PROMO_CODES`, `STORE_GROUP_FULL`, `STORE_GROUP_DELTA`.
*   `feedSourceName` (_string_)
*   `feedSourceType` (_string_)  
    Allowed values: `URL`, `SFTP`, `FTP`, `S3`, `YEXT`, `AVALARA`, `SABRIX`, `AVALARA_V2`, `VERTEX`, `SPI`, `WEBDAV`.
*   `fileNames` (_array of string_)
*   `feedFileType` (_string_)  
    Allowed values: `CSV`, `TSV`, `SSV`, `PSV`, `XML`, `STORE_XML`, `INVENTORY_XML`, `JSON`, `YEXT`, `ASN_EDI_856`, `OTHER`.
*   `feedPreprocessorClass` (_string_)
*   `feedFileMetadataList` (_array of FeedFileMetadata_)
*   `baseURL` (_string_)
*   `urlRequestParams` (_string_)
*   `folderName` (_string_)
*   `host` (_string_)
*   `port` (_integer (int32)_)
*   `userName` (_string_)
*   `password` (_string_)
*   `s3FeedTimestamp` (_integer (int64)_)
*   `parentTag` (_string_)
*   `multiValueFieldList` (_array of string_)
*   `preserveIfNullFieldList` (_array of string_)
*   `currencyCode` (_string_)
*   `idColumn` (_string_)
*   `multiValueFieldDelimiter` (_string_)
*   `columnNames` (_string_)
*   `promotionId` (_string_)
*   `deleteFeed` (_boolean_)
*   `addFeed` (_boolean_)
*   `updateFeed` (_boolean_)
*   `fullFeed` (_boolean_)
*   `sourceEncoding` (_string_)
*   `maxRecordsToProcess` (_integer (int32)_)
*   `apiKey` (_string_)
*   `version` (_string_)
*   `categoryProductRankColumnName` (_string_)
*   `productIdFieldName` (_string_)
*   `feedName` (_string_)
*   `feedDescription` (_string_)
*   `isProductBundleCategorySource` (_boolean_)
*   `importPromotions` (_boolean_)
*   `hasCategories` (_boolean_)
*   `shouldProcessCategoryCounts` (_boolean_)
*   `skipFields` (_string_)
*   `hasProductMultiPromotions` (_boolean_)
*   `fieldDelimiter` (_string_)
*   `endLineDelimiter` (_string_)
*   `deviceOS` (_string_)
*   `dataSource` (_string_)  
    Allowed values: `NETSUITE`.
*   `accountId` (_string_)
*   `licenseKey` (_string_)
*   `merchantReferenceCode` (_string_)
*   `bulkProcessing` (_boolean_)
*   `backUp` (_boolean_)
*   `continueOnFileError` (_boolean_)
*   `clientId` (_string_)
*   `clientSecret` (_string_)
*   `hasActualInventoryCount` (_boolean_)
*   `oauthHost` (_string_)

### CombinationGroup

Products that receive the discount when the qualifying condition is met.

*   `quantity` (_integer (int32)_)
*   `quantityOperator` (_string_)  
    Allowed values: `EQL`, `GTE`.
*   `productRules` (_array of PromotionRule_)

### PromotionRule

Promotion rule provides the filtering criteria to determine if the order is eligible for promotion.

*   `promotionRuleId` (_string_)
*   `promotionId` (_string_)
*   `operator` (_string_, nullable) Operation to be performed for the rule depending on the value types.  
    Allowed values: `DOES_NOT_CONTAIN`, `CONTAINS`, `GTE`, `LTE`, `EXISTS`, `NOT_EXISTS`.
*   `value` (_array of string_, nullable) Values are based on the value Types. They contain a list and for single value attributes use a list of size 1.  
    Unique items.
*   `valueType` (_string_, nullable) Value Type provides the type of value.

### TierGroup

*   `amountExpression` (_string_)
*   `tierRules` (_array of PromotionRule_)
*   `id` (_string_)
*   `selectedProducts` (_array of string_)

### PromotionLanguageData

Promotion attributes in additional languages.

*   `promotionId` (_string_)
*   `language` (_string_) The language/locale of properties for this object.
*   `name` (_string_) The name used for internal identification of the promotion. This field can also be used to assign a locale/language-specific name for the promotion.
*   `title` (_string_) The locale/language-specific title used for external display of the promotion on the presentation layer.
*   `description` (_string_) The locale/language-specific description used for external display of the promotion on the presentation layer. This contains the disclaimer and other information.

### PromotionMapping

*   `quantityOperator` (_string_)  
    Allowed values: `EQL`, `GTE`.
*   `merchantId` (_string_)
*   `type` (_string_)  
    Allowed values: `QUALIFYING_GROUP`, `DISCOUNTED_GROUP`, `TIER_GROUP`, `FREE_SAMPLES`.
*   `promotionRulesGroupId` (_string_)
*   `promotionMappingId` (_string_)
*   `promotionId` (_string_)
*   `amountExpression` (_string_)
*   `quantity` (_integer (int32)_)
*   `locale` (_string_)
*   `region` (_string_)

### PromotionCode

*   `merchantId` (_string_)
*   `region` (_string_)
*   `promotionId` (_string_)
*   `oneTimeCode` (_string_)
*   `oneTimeCodeCS` (_string_)
*   `codeType` (_string_)
*   `externalId` (_string_)
*   `codeAssignedDate` (_string (date-time)_)
*   `codeRedeemed` (_boolean_)
*   `codeRedeemedDate` (_string (date-time)_)
*   `storeCode` (_string_)
*   `promotionValidDate` (_string (date-time)_)
*   `type` (_string_)
*   `message` (_string_)
*   `validFrom` (_string (date-time)_)
*   `validTo` (_string (date-time)_)
*   `updatedOn` (_string (date-time)_)

### CustomerOrder

*   `errorMessage` (_string_, nullable) Error message shown to the user.  
    Example: `Invalid request. Please check the request and try again.`.
*   `errorCode` (_string_, nullable) Error code shown to the user.  
    Example: `INTERNAL_ERROR`.
*   `orderId` (_string_, required) Order Identifier.  
    Maximum length: 128. Example: `PS00027533`.
*   `quoteId` (_string_, nullable) Quote reference identifier. Links the order to a quote. Available when the order is based on a quote.  
    Maximum length: 128.
*   `externalQuoteId` (_string_, nullable) External quote reference identifier. Quote ID from the external system. Available when the order is based on a quote.  
[...]
